/* Copyright (c) 2011 Asustor Inc. All rights reserved. */

Ext.ns('AS.ARC.ftpexplorer');

/**
 * @class AS.ARC.apps.ftpexplorer.core
 * @extends Ext.util.Observable
 * <p>core</p>
 */
Ext.define('AS.ARC.apps.ftpexplorer.core', {
	extend: 'Ext.util.Observable',

	imageUrl: AS.ARC.util.getUserAppsPath() + 'ftpexplorer/images/',
	apiUrl : AS.ARC.util.getUserAppsPath() + 'ftpexplorer/ftpexplorer.cgi',
	apiFileExplorerUrl : AS.ARC.util.getApiUrl('fileExplorer.cgi', 'fileExplorer'),
	
	anonymousUsername: 'anonymous',
	
	typearray : [
		'3g2', 
		'3gp', 
		'asf',
		'asx',
		'avi',
		'flv',
		'm3u',
		'm4a',
		'mkv',
		'mov',
		'mp3',
		'mp4',
		'mpa',
		'mpeg',
		'mpg',
		'rec',
		'rm',
		'rmvb',
		'vob',
		'wmv',
		'wsf',
		'jpg',
		'png',
		'gif',
		'bmp',
		'eps',
		'jpeg',
		'tif',
		'doc',
		'docx',
		'txt',
		'excel',
		'xlsx',
		'xls',
		'html',
		'pdf',
		'power-point',
		'pptx',
		'ppt',
		'word',
		'xml',
		'7z',
		'zip',
		'rar',
		'gz',
		'tar',
		'wim',
		'gzip',
		'iso',
		'exe'
	],
	typeUrl : [
		'3G2.png',
		'3gp.png',
		'asf.png',
		'asx.png',
		'avi.png',
		'flv.png',
		'm3u.png',
		'm4a.png',
		'mkv.png',
		'mov.png',
		'mp3.png',
		'mp4.png',
		'mpa.png',
		'mpeg.png',
		'mpg.png',
		'rec.png',
		'rm.png',
		'rmvb.png',
		'vob.png',
		'wmv.png',
		'wsf.png',
		'jpg.png',
		'png.png',
		'gif.png',
		'bmp.png',
		'eps.png',
		'jpeg.png',
		'tif.png',
		'word.png',
		'word.png',
		'txt.png',
		'excel.png',
		'excel.png',
		'excel.png',
		'html.png',
		'pdf.png',
		'power-point.png',
		'power-point.png',
		'power-point.png',
		'word.png',
		'xml.png',
		'7z.png',
		'zip.png',
		'rar.png',
		'gz.png',
		'tar.png',
		'wim.png',
		'gzip.png',
		'iso.png',
		'exe.png'
		
	],
	constructor: function (config) {
		Ext.apply(this, config);
		this.callParent();

		this.init();
	},
	init: function () {
		var fn = this;
		fn.init = true;
		fn.manualFalg = false;
		fn.ftpHost ='';
		fn.ftpPort = '';
		fn.settingMode = '';
		fn.ftpPageSize = 500;
		fn.nasPageSize = 500;
		
		// Field validation Vtypes
		Ext.form.VTypes.settingSiteName = function (v,f) {
			var maxLength = 64;

			if (v.length > maxLength) {
				Ext.form.VTypes.settingSiteNameText = Ext.String.format(_S('MESSAGE', 'HF00016'), maxLength);
				return false;
			}else {
				Ext.form.VTypes.settingSiteNameText = _S('FTP_EXPLORER', 'SITE_NAME_ALREADY_EXIST');
				if(f.mode == 'add'){
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'server_check_name'}),
						method: 'post',
						params:{site_name:v, exclude_site_name:''},
						success: function (json, opts) {
							if(typeof json !== 'undefined'){
								f.clearInvalid();
								return true;
							}
						},
						failure: function (json, opts) {
							return false;
						}

					});
				} else {
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'server_check_name'}),
						method: 'post',
						params:{site_name:v, exclude_site_name:f.originalValue},
						success: function (json, opts) {
							if(typeof json !== 'undefined'){
								f.clearInvalid();
								return true;
							}
						},
						failure: function (json, opts) {
							return false;
						}

					});
				}
			}
			return true;
		};
		
		Ext.form.VTypes.settingHostMask = /[0-9a-zA-Z \s\+\-\*\~\`!$%^&()\_=|\\{};<>,.]/;
		Ext.form.VTypes.settingHostMaskRe = /^[0-9a-zA-Z \s\+\-\*\~\`!$%^&()\_=|\\{};<>,.]*$/;
		Ext.form.VTypes.settingHostText = _S('MESSAGE', 'HF00011');
		Ext.form.VTypes.settingHost = function (v,f) {
			var maxLength = 255;
			if (v.length > maxLength) {
				Ext.form.VTypes.settingHostText = Ext.String.format(_S('MESSAGE', 'HF00016'), maxLength);
				return false;
			} else {
				return Ext.form.VTypes.settingHostMaskRe.test(v);
			}
		};
		
		function disconnect(isClose) {
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'disconnect'}),
				method: 'post',
				success: function (json, opts) {
					if (fn.connectpanel.items.length === 0) 
						return;

					fn.connectpanel.items.get('hostIP').setValue();
					fn.connectpanel.items.get('port').setValue(21);
					fn.connectpanel.items.get('username').setValue();
					fn.connectpanel.items.get('password').setValue();
					fn.connectpanel.items.get('disconnect').disable();
					fn.ftpHost = '';
					fn.ftpPort = '';

					fn.ftpGrid.dockedItems.items[1].updateInfo();
					fn.ftpPanel.dockedItems.items[0].items.get('ftppath').setValue();
					
					fn.ftpGrid.store.loadData([]);
				},
				failure: function (json, opts) {
					if (isConnect()) {
						fn.connectpanel.items.get('disconnect').enable();
					} else {
						fn.connectpanel.items.get('disconnect').disable();
					}
				
					AS.ARC.util.showMsgWindow({
						5011: _S('FTP_EXPLORER','ERROR_5011')
					}, json, fn.win);
				}
			});
		};
		function isConnected(fromServer) {
			if (fromServer) {
				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'is_connected'}),
					method: 'post',
					success: function (json, opts) { },
					failure: function (json, opts) { }
				});
			} else {
				return !!fn.ftpHost;
			}
		};
		function mainConnect() {
			var username = fn.connectpanel.items.get('username').getValue(),
				serverInfo = fn.connectpanel.items.get('hostIP').getValue();
			
			if (serverInfo.trim() == '') return;
			
			if (username == fn.anonymousUsername) {username = '';}
			
			fn.ftpPanel.el.mask(Ext.String.format(_S('FTP_EXPLORER','CONNECTING'),fn.connectpanel.items.get('hostIP').getValue()));
			
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'connect'}),
				method: 'post',
				params: {
					server_info: serverInfo,
					port: fn.connectpanel.items.get('port').getValue(),
					username: username,
					password: fn.connectpanel.items.get('password').getValue(),
					login_type: (username.trim() == '') ? 1 : 0,
					encryption: 0,
					transfer_mode: 1,
					file_existing_mode: 0
				},
				success: function (json, opts) {
					if (typeof json !== 'undefined'){
						if (!username) {
							fn.connectpanel.items.get('username').setValue('anonymous');
						}

						fn.connectpanel.items.get('disconnect').enable();

						fn.ftpHost = fn.connectpanel.items.get('hostIP').getValue();
						fn.ftpPort = fn.connectpanel.items.get('port').getValue();
						fn.ftpStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act:'ftp_list',ftp_dir:''});
						fn.ftpStore.load();
						fn.ftpPanel.dockedItems.items[0].items.get('ftppath').setValue('/');
					}
				},
				failure: function (json, opts) {
					fn.ftpPanel.el.unmask();

					disconnect();

					AS.ARC.util.showMsgWindow({
						5601: Ext.String.format(_S('FTP_EXPLORER','ERROR_UNABLE_CONNECT'), fn.connectpanel.items.get('hostIP').getValue()),
						5026: _S('ERROR', 'SYSTEM_READ_ONLY')
					}, json, fn.win);
				}
			});
		};
		function settingConnect() {
			var itemsData = fn.serverListGrid.getSelectionModel().selected.items[0].data;
			
			var urlOpts = {
				act: 'connect',
				server_info: itemsData.server_info,
				port: itemsData.port,
				username: itemsData.username,
				password: itemsData.password,
				login_type: itemsData.login_type,
				encryption: itemsData.encryption,
				transfer_mode: itemsData.transfer_mode,
				file_existing_mode: itemsData.file_existing_mode
			};
			
			var connect = function () {
				fn.settingWin.el.mask(Ext.String.format(_S('FTP_EXPLORER','CONNECTING'),itemsData.server_info));
				
				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, urlOpts),
					method: 'post',
					success: function (json, opts) {
						if(typeof json !== 'undefined'){
						
							fn.connectpanel.items.get('disconnect').enable();
						
							var itemsData = fn.serverListGrid.getSelectionModel().selected.items[0].data;
							fn.connectpanel.items.get('hostIP').setValue(itemsData.server_info);
							fn.connectpanel.items.get('port').setValue(itemsData.port);
							fn.connectpanel.items.get('username').setValue(itemsData.username || fn.anonymousUsername);
							fn.connectpanel.items.get('password').setValue(itemsData.password);
							fn.ftpStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act:'ftp_list',ftp_dir:''});
							var ftpPagingBar =  fn.ftpGrid.dockedItems.items[1];
							ftpPagingBar.store.loadPage(1);
							fn.ftpPanel.dockedItems.items[0].items.get('ftppath').setValue('/');
							fn.ftpHost = itemsData.server_info;
							fn.ftpPort = itemsData.port;
							fn.settingWin.close();
						}
					},
					failure: function (json, opts) {
						fn.settingWin.el.unmask();

						disconnect();

						AS.ARC.util.showMsgWindow({
							5601:Ext.String.format(_S('FTP_EXPLORER','ERROR_UNABLE_CONNECT'),itemsData.server_info),
							5026: _S('ERROR', 'SYSTEM_READ_ONLY')
						}, json, fn.settingWin);

					}
				});
			};

			if (isConnected()) {
				var win = new AS.ARC.msgWindow({
					title: _S('FTP_EXPLORER', 'CONFIRMATION'),
					iconType: 'info',
					parentWin: fn.settingWin,
					asItems: [{
						xtype: 'displayfield',
						value: _S('FTP_EXPLORER', 'RELINK_MSG')
					}],
					fbar: {
						items: [{
							text: _S('COMMON', 'OK'),
							handler: function (btn) {
								btn.disable();
								btn.next().disable();
								win.close();
								
								connect();
								
							},
							scope: this
						},{
							text: _S('COMMON', 'CANCEL'),
							handler: function (btn) {
								btn.disable();
								btn.prev().disable();
								win.close();
							},
							scope: this
						}]
					}
				}).show();
			} else {
				connect();
			}
		};
		function relink(parentWin){
			var win = new AS.ARC.msgWindow({
				title: _S('FTP_EXPLORER', 'CONFIRMATION'),
				iconType: 'info',
				parentWin: (parentWin) ? parentWin : fn.win,
				asItems: [{
					xtype: 'displayfield',
					value: _S('FTP_EXPLORER', 'RELINK_MSG')
				}],
				fbar: {
					items: [{
						text: _S('COMMON', 'OK'),
						handler: function (btn) {
							btn.disable();
							btn.next().disable();
							win.close();
							
							if (parentWin) {
								parentWin.close();
							}
							
							fn.ftpPanel.el.mask(Ext.String.format(_S('FTP_EXPLORER','CONNECTING'),fn.connectpanel.items.get('hostIP').getValue()));
							
							var username = fn.connectpanel.items.get('username').getValue();
							
							if (username == fn.anonymousUsername) {username = '';}
							
							AS.ARC.ajax({
								url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'connect'}),
								method: 'post',
								params: {
									server_info: fn.connectpanel.items.get('hostIP').getValue(),
									port: fn.connectpanel.items.get('port').getValue(),
									username: username,
									password: fn.connectpanel.items.get('password').getValue(),
									login_type: (username.trim() == '') ? 1 : 0,
									encryption: 0,
									transfer_mode: 1,
									file_existing_mode: 0
								},
								success: function (json, opts) {
									if(typeof json !== 'undefined'){
										if (!username) {
											fn.connectpanel.items.get('username').setValue('anonymous');
										}

										fn.connectpanel.items.get('disconnect').enable();

										fn.ftpHost = fn.connectpanel.items.get('hostIP').getValue();
										fn.ftpPort = fn.connectpanel.items.get('port').getValue();
										fn.ftpStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act:'ftp_list',ftp_dir:''});
										var ftpPagingBar =  fn.ftpGrid.dockedItems.items[1];
										ftpPagingBar.store.loadPage(1);
										fn.ftpPanel.dockedItems.items[0].items.get('ftppath').setValue('/');
									}
								},
								failure: function (json, opts) {
									fn.ftpPanel.el.unmask();

									disconnect();

									AS.ARC.util.showMsgWindow({
										5011: _S('FTP_EXPLORER','ERROR_5011'),
										5601: Ext.String.format(_S('FTP_EXPLORER','ERROR_UNABLE_CONNECT'), fn.connectpanel.items.get('hostIP').getValue()),
										5026: _S('ERROR', 'SYSTEM_READ_ONLY')
									}, json, fn.win);
								}
							});
						},
						scope: this
					},{
						text: _S('COMMON', 'CANCEL'),
						handler: function (btn) {
							btn.disable();
							btn.prev().disable();
							win.close();
						},
						scope: this
					}]
				}
			});
			
			// to prevent the ENTER key trigger the OK button
			setTimeout(function () {
				win.show();
			}, 10);
			
		};
		function activityInfo(cid){
			var getInfoData = function(){
				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'activity_info',cid:cid}),
					method: 'post',
					success: function (json, opts) {
						if(typeof json !== 'undefined'){
							var data = json.info,
								store = gridInfo.getStore();
								
							store.getAt(0).set('value', data.name);
							store.getAt(0).commit();
							store.getAt(1).set('value', data.server_address);
							store.getAt(1).commit();
							store.getAt(2).set('value', data.transfer_mode== 0 ? _S('COMMON','DOWNLOAD'): _S('COMMON','UPLOAD'));
							store.getAt(2).commit();
							store.getAt(4).set('value', data.destination);
							store.getAt(4).commit();
							store.getAt(5).set('value', AS.ARC.util.convertSizeUnit(data.speed) + '/s');
							store.getAt(5).commit();
							store.getAt(6).set('value', AS.ARC.util.convertTime(data.elapsed_time));
							store.getAt(6).commit();
							store.getAt(8).set('value', _S('FTP_EXPLORER', 'PROCESSING'));
							store.getAt(8).commit();
							
							if (typeof data.status === 'undefined') {
								var source = data.source.splice(','),
									dataSource = '';
								
								source.forEach(function(data){
									dataSource += (dataSource.length == 0) ? '' : '<br>';
									dataSource += data;
								});
								
								store.getAt(3).set('value', dataSource);
								store.getAt(3).commit();
								
								if(data.eta != -1) {
									store.getAt(7).set('value', AS.ARC.util.convertTime(data.eta));
									store.getAt(7).commit();
								}else{
									store.getAt(7).set('value', _S('COMMON','CACULATING'));
									store.getAt(7).commit();
								}
								
								progressBar.updateProgress(data.progress/100);
								progressBar.updateText(parseInt(data.progress) + '%');
								InfoID = setTimeout(function(){
									getInfoData();
								},3000);
								
							} else {
								store.getAt(7).set('value', 0);
								store.getAt(7).commit();
								
								if (data.status === 1) {
									progressBar.updateProgress(1);
									progressBar.updateText(100 + '%');
									store.getAt(8).set('value', _S('COMMON', 'WARNING'));
								} else if (data.status === 2) {
									store.getAt(8).set('value', _S('COMMON', 'ERROR'));
								} else {
									progressBar.updateProgress(1);
									progressBar.updateText(100 + '%');
									store.getAt(8).set('value', _S('COMMON', 'FINISH'));
								}
								store.getAt(8).commit();
							}
							gridInfo.determineScrollbars();
						}
					},
					failure: function (json, opts) {
						AS.ARC.util.showMsgWindow({
						
						}, json, fn.win);
					}
				});
			};
				
			var gridInfo = Ext.create('Ext.grid.Panel', {
				border: false,
				height: 338,
				store: Ext.create('Ext.data.Store', {
					fields: ['name','value'],
					data: [{
						name: _S('COMMON', 'NAME'),
						value: ''
					}, {
						name: _S('FTP_EXPLORER', 'SERVER_ADDR'),
						value: ''
					},{
						name: _S('FTP_EXPLORER', 'TRANSFER_MODE'),
						value: ''
					}, {
						name: _S('FTP_EXPLORER', 'SOURCE'),
						value: ''
					},{
						name: _S('FTP_EXPLORER', 'DESTINATION'),
						value: ''
					},{
						name: _S('FTP_EXPLORER', 'SPEED'),
						value: ''
					},{
						name: _S('FTP_EXPLORER', 'ELAPSED_TIME'),
						value: ''
					},{
						name: _S('FTP_EXPLORER', 'ETA'),
						value: ''
					}, {
						name: _S('COMMON', 'STATUS'),
						value: ''
					}]
				}),
				columns: [{
					text: _S('COMMON', 'NAME'),
					flex: 2,
					sortable: false,
					dataIndex: 'name'
				}, {
					text: _S('COMMON', 'VALUE'),
					flex: 5,
					sortable: false,
					dataIndex: 'value',
					renderer: function (value, metadata, record, index) {
						var displayColumns = [_S('COMMON', 'NAME'), _S('FTP_EXPLORER', 'SERVER_ADDR'), _S('FTP_EXPLORER', 'SOURCE'),
												_S('FTP_EXPLORER', 'DESTINATION')];
						if (displayColumns.indexOf(record.data.name) !== -1) {
							metadata.tdAttr = 'data-qtip="' + value + '"';
						} else {
                            if(value === '-1.00 B/s') {
                                value = _S('FTP_EXPLORER', 'PROCESSING');
                            }
                        }
						return value;
					}
				}]
			});
			var progressBar = Ext.create('Ext.ProgressBar', {
				hidden: false,
				margin: '10 0 0 0',
				listeners:{
					afterrender:function(obj){
						obj.getEl().child(".x-progress-bar", true).style.height = 18;
						obj.getEl().child(".x-progress-bar", true).style.backgroundImage  = 'url('+fn.imageUrl + 'loadingbar_16.png)';
					}
				}
			});
			var win = Ext.create('AS.ARC.subWindow', {
				title: _S('COMMON', 'INFORMATION'),
				parentWin: fn.win,
				width: 625,
				height: 500,
				layout: 'fit',
				items: [{
					xtype: 'asPanelTop10',
					items: [
						gridInfo,
						progressBar
					]
				}],
				fbar: {
					items: [{
						text: _S('COMMON', 'CLOSE'),
						handler: function () {
							clearTimeout(InfoID);
							win.close()
						},
						scope: this
					}]
				},
				listeners: {
					show: function () {
						InfoID = -1;
					}
				}
			});
			win.show();
			getInfoData();
		};
		function activityQueue(cid){
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'process_queue',cid:cid}),
				method: 'post',
				success: function (json, opts) {
					if(typeof json !== 'undefined'){
						clearTimeout(fn.activityID);
						fn.activityStore.load();
					}
				},
				failure: function (json, opts) {
					AS.ARC.util.showMsgWindow({ }, json, fn.win);
				}
			});
		};
		function activityRemove(cid){
			clearTimeout(fn.activityID);
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'remove_task',cid:cid}),
				method: 'post',
				success: function (json, opts) {
					if(typeof json !== 'undefined'){
						clearTimeout(fn.activityID);
						fn.activityStore.load();
						fn.resultStore.load();
					}
				},
				failure: function (json, opts) {
					fn.activityStore.load();
					AS.ARC.util.showMsgWindow({ }, json, fn.win);
				}
			});
		};
		function restart(cid){
			var doRestart = function (resume) {
				win.el.mask(_S('COMMON', 'APPLYING'));
				AS.ARC.ajax({
					url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'restart_task'}),
					params: {
						cid: cid,
						resume: resume
					},
					method: 'post',
					success: function (json, opts) {
						win.close();
						if(typeof json !== 'undefined'){
							fn.resultStore.load();
							clearTimeout(fn.activityID);
							fn.activityStore.load();
						}
					},
					failure: function (json, opts) {
						win.el.unmask();
						AS.ARC.util.showMsgWindow({ }, json, win);
					}
				});
			};
			
			var win = Ext.create('AS.ARC.subWindow', {
				title: _S('FTP_EXPLORER', 'RESTART'),
				parentWin: fn.win,
				width: 550,
				height: 300,
				layout: 'fit',
				items: [{
					xtype: 'asPanelTop20',
					itemId: 'panel',
					items: [{
						xtype: 'radio',
						itemId: 'restart',
						name: 'restart-mode',
						boxLabel: _S('FTP_EXPLORER', 'RESTART_FILE_TRANSFER'),
						value: 0,
						checked: true
					}, {
						xtype: 'displayfield',
						cls: 'displayField',
						value: _S('FTP_EXPLORER', 'RESTART_FILE_TRANSFER_DESC'),
						style: {marginLeft: '25px'}
					}, {
						xtype: 'radio',
						itemId: 'resume',
						name: 'restart-mode',
						boxLabel: _S('FTP_EXPLORER', 'RESUME_FILE_TRANSFER'),
						value: 1
					}, {
						xtype: 'displayfield',
						cls: 'displayField',
						value: _S('FTP_EXPLORER', 'RESUME_FILE_TRANSFER_DESC'),
						style: {marginLeft: '25px'}
					}]
				}],
				fbar: {
					items: [{
						text: _S('COMMON', 'OK'),
						handler: function () {
							var v = (win.items.get('panel').items.get('resume').getValue() ? 1 : 0);
							doRestart(v);
						},
						scope: this
					},{
						text: _S('COMMON', 'CANCEL'),
						handler: function () {
							win.close();
						},
						scope: this
					}]
				}
			}).show();
			
		};
		function settingAdd() {
			fn.settingMode = 'add';
			var settingAddTab = new Ext.create('Ext.tab.Panel', {
				cls: 'app-ftp-setting-add',
				items: [{
					title: _S('COMMON','GENERAL'),
					itemId:'setting-add-general',
					height: 300,
					items: [
					{
						xtype: 'textfield',
						itemId: 'add-sitename',
						cls: 'ftp-setting-sitename',
						fieldLabel: _S('FTP_EXPLORER', 'SITE_NAME'),
						msgTarget: AS.ARC.config.msgTarget,
						enableKeyEvents: true,
						checkChangeBuffer: AS.ARC.config.keyBuffer,
						allowBlank: false,
						blankText: _S('MESSAGE', 'HF00011'),
						labelWidth: 200,
						width: 480,
						emptyText: _S('FTP_EXPLORER', 'SITE_NAME'),
						vtype:'settingSiteName',
						mode:'add',
						listeners:{
							change:function(field){
								var generalItem = settingAddTab.items.get('setting-add-general').items,
									connectBtn = win.dockedItems.items[1].items.items[0];
									saveBtn = win.dockedItems.items[1].items.items[1];
								
								if(generalItem.get('add-sitename').getValue() !=='' && generalItem.get('add-host').getValue() !== ''
								&& generalItem.get('add-port').getValue() !== null && generalItem.get('add-logintype').getValue() == 0){
									//login type = normal
                                    // generalItem.get('add-password').getValue() !== '' &&
									
									if(generalItem.get('add-username').getValue() !== '' && generalItem.get('add-port').isValid()){
										connectBtn.enable();
										saveBtn.enable();
									}else{
										connectBtn.disable();
										saveBtn.disable();
									}
								}else if(generalItem.get('add-sitename').getValue() !=='' && generalItem.get('add-host').getValue() !== ''
								&& generalItem.get('add-port').getValue() !== null && generalItem.get('add-logintype').getValue() == 1){
									connectBtn.enable();
									saveBtn.enable();
								}else{
									connectBtn.disable();
									saveBtn.disable();
								}
							}
						}
					}, {
						xtype: 'displayfield',
						cls: 'ftp-setting-sitename-img',
						width: 24,
						height: 24
					}, {
						xtype: 'textfield',
						itemId: 'add-host',
						cls: 'ftp-setting-host',
						msgTarget: AS.ARC.config.msgTarget,
						width: 480,
						labelWidth: 200,
						emptyText: _S('FTP_EXPLORER', 'HOSTIP'),
						fieldLabel: _S('FTP_EXPLORER', 'SERVER_INFO'),
						vtype:'settingHost',
						listeners:{
							change:function(){
								var generalItem = settingAddTab.items.get('setting-add-general').items,
									connectBtn = win.dockedItems.items[1].items.items[0];
									saveBtn = win.dockedItems.items[1].items.items[1];
	
								if(generalItem.get('add-sitename').getValue() !=='' && generalItem.get('add-host').getValue() !== ''
								&& generalItem.get('add-port').getValue() !== null && generalItem.get('add-logintype').getValue() == 0){
									//login type = normal  
                                    //&& generalItem.get('add-password').getValue() !== ''
									if(generalItem.get('add-username').getValue() !== ''
									&& generalItem.get('add-port').isValid()){
										connectBtn.enable();
										saveBtn.enable();
									}else{
										connectBtn.disable();
										saveBtn.disable();
									}
								}else if(generalItem.get('add-sitename').getValue() !=='' && generalItem.get('add-host').getValue() !== ''
								&& generalItem.get('add-port').getValue() !== null && generalItem.get('add-logintype').getValue() == 1){
									connectBtn.enable();
									saveBtn.enable();
								}else{
									connectBtn.disable();
									saveBtn.disable();
								}
							}
						}
					}, {
						xtype: 'displayfield',
						cls: 'ftp-setting-host-img',
						width: 24,
                        height: 24
					}, {
						xtype: 'numberfield',
						itemId: 'add-port',
						cls: 'ftp-setting-port',
						msgTarget: AS.ARC.config.msgTarget,
						width: 276,
						allowDecimals:false,
						hideTrigger:false,
						emptyText:_S('FTP_EXPLORER','Port'),
						maxValue: 65535,
						minValue: 1,
						value: 21,
						style: 'display:inline-block;position:relative;left:205px;',
						listeners:{
							change:function(){
								var generalItem = settingAddTab.items.get('setting-add-general').items,
									connectBtn = win.dockedItems.items[1].items.items[0];
									saveBtn = win.dockedItems.items[1].items.items[1];

								if(generalItem.get('add-sitename').getValue() !=='' && generalItem.get('add-host').getValue() !== ''
								&& generalItem.get('add-port').getValue() !== null && generalItem.get('add-logintype').getValue() == 0){
									//login type = normal
                                    // && generalItem.get('add-password').getValue() !== ''
									if(generalItem.get('add-username').getValue() !== ''
									&& generalItem.get('add-port').isValid()){
										connectBtn.enable();
										saveBtn.enable();
									}else{
										connectBtn.disable();
										saveBtn.disable();
									}
								}else if(generalItem.get('add-sitename').getValue() !=='' && generalItem.get('add-host').getValue() !== ''
								&& generalItem.get('add-port').getValue() !== null && generalItem.get('add-logintype').getValue() == 1){
									connectBtn.enable();
									saveBtn.enable();
								}else{
									connectBtn.disable();
									saveBtn.disable();
								}
							}
						}
					}, {
						xtype: 'displayfield',
						cls: 'ftp-setting-port-img',
						width: 24,
                        height: 24
					}, {
						xtype: 'combobox',
						itemId: 'add-logintype',
						cls: 'ftp-setting-logintype',
						fieldLabel: _S('FTP_EXPLORER', 'LOGIN_TYPE'),
						msgTarget: AS.ARC.config.msgTarget,
						editable: false,
						width: 480,
						labelWidth: 200,
						displayField:'display',
						valueField: 'value',
						value:0,
						store: new Ext.data.ArrayStore({
							fields: ['display', 'value'],
							data: [
								[_S('FTP_EXPLORER','NORMAL'), 0],
								[_S('FTP_EXPLORER','ANONYMOUS'), 1]
							]
						}),
						listeners:{
							select:function(combo, records, eOpts ){
								if(records[0].data.value == 1){
									settingAddTab.items.items[0].items.get('add-username').disable();
									settingAddTab.items.items[0].items.get('add-password-icon').disable();
									settingAddTab.items.items[0].items.get('add-password').disable();
								}else{
									settingAddTab.items.items[0].items.get('add-username').enable();
									settingAddTab.items.items[0].items.get('add-password-icon').enable();
									settingAddTab.items.items[0].items.get('add-password').enable();
								}
							},
							change:function(){
								var generalItem = settingAddTab.items.get('setting-add-general').items,
									connectBtn = win.dockedItems.items[1].items.items[0];
									saveBtn = win.dockedItems.items[1].items.items[1];
								if(generalItem.get('add-sitename').getValue() !=='' && generalItem.get('add-host').getValue() !== ''
								&& generalItem.get('add-port').getValue() !== null && generalItem.get('add-logintype').getValue() == 0){
									//login type = normal 
                                    // && generalItem.get('add-password').getValue() !== ''
									if(generalItem.get('add-username').getValue() !== ''
									&& generalItem.get('add-port').isValid()){
										connectBtn.enable();
										saveBtn.enable();
									}else{
										connectBtn.disable();
										saveBtn.disable();
									}
								}else if(generalItem.get('add-sitename').getValue() !=='' && generalItem.get('add-host').getValue() !== ''
								&& generalItem.get('add-port').getValue() !== null && generalItem.get('add-logintype').getValue() == 1){
									connectBtn.enable();
									saveBtn.enable();
								}else{
									connectBtn.disable();
									saveBtn.disable();
								}
							}
						}
					}, {
						xtype: 'displayfield',
						cls: 'ftp-setting-logintype-img',
						width: 24,
                        height: 24
					}, {
						xtype: 'textfield',
						itemId: 'add-username',
						cls: 'ftp-setting-username',
						msgTarget: AS.ARC.config.msgTarget,
						fieldLabel: _S('FTP_EXPLORER', 'AUTHENTICATION'),
						emptyText:_S('FTP_EXPLORER','USERNAME'),
						width: 480,
						labelWidth: 200,
						listeners:{
							change:function(){
								var generalItem = settingAddTab.items.get('setting-add-general').items,
									connectBtn = win.dockedItems.items[1].items.items[0];
									saveBtn = win.dockedItems.items[1].items.items[1];

								if(generalItem.get('add-sitename').getValue() !=='' && generalItem.get('add-host').getValue() !== ''
								&& generalItem.get('add-port').getValue() !== null && generalItem.get('add-logintype').getValue() == 0){
									//login type = normal
                                    // && generalItem.get('add-password').getValue() !== ''
									if(generalItem.get('add-username').getValue() !== ''
									&& generalItem.get('add-port').isValid()){
										connectBtn.enable();
										saveBtn.enable();
									}else{
										connectBtn.disable();
										saveBtn.disable();
									}
								}else if(generalItem.get('add-sitename').getValue() !=='' && generalItem.get('add-host').getValue() !== ''
								&& generalItem.get('add-port').getValue() !== null && generalItem.get('add-logintype').getValue() == 1){
									connectBtn.enable();
									saveBtn.enable();
								}else{
									connectBtn.disable();
									saveBtn.disable();
								}
							}
						}
					}, {
						xtype: 'displayfield',
						cls: 'ftp-setting-username-img',
						width: 24,
                        height: 24
					}, {
						xtype: 'textfield',
						itemId: 'add-password',
						cls: 'ftp-setting-password',
						msgTarget: AS.ARC.config.msgTarget,
						inputType: 'password',
						emptyText:_S('FTP_EXPLORER','PASSWORD'),
						width: 276,
						style: 'display:inline-block;position:relative;left:205px;',
						listeners:{
							change:function(){
								var generalItem = settingAddTab.items.get('setting-add-general').items,
									connectBtn = win.dockedItems.items[1].items.items[0];
									saveBtn = win.dockedItems.items[1].items.items[1];

								if(generalItem.get('add-sitename').getValue() !=='' && generalItem.get('add-host').getValue() !== ''
								&& generalItem.get('add-port').getValue() !== null && generalItem.get('add-logintype').getValue() == 0){
									//login type = normal
                                    // && generalItem.get('add-password').getValue() !== ''
									if(generalItem.get('add-username').getValue() !== ''
									&& generalItem.get('add-port').isValid()){
										connectBtn.enable();
										saveBtn.enable();
									}else{
										connectBtn.disable();
										saveBtn.disable();
									}
								}else if(generalItem.get('add-sitename').getValue() !=='' && generalItem.get('add-host').getValue() !== ''
								&& generalItem.get('add-port').getValue() !== null && generalItem.get('add-logintype').getValue() == 1){
									connectBtn.enable();
									saveBtn.enable();
								}else{
									connectBtn.disable();
									saveBtn.disable();
								}
							}
						}
					}, {
						xtype: 'displayfield',
						itemId: 'add-password-icon',
						cls: 'ftp-setting-password-img',
						width: 24,
                        height: 24
					}]
				},{
					title: _S('COMMON','ADVANCED'),
					itemId:'setting-add-advanced',
					height: 300,
					items: [
					{
						xtype: 'combobox',
						itemId: 'add-encryption',
						cls: 'ftp-setting-encryption',
						fieldLabel: _S('FTP_EXPLORER', 'ENCRYPTION'),
						labelWidth: 200,
						width: 480,
						editable: false,
						displayField:'display',
						valueField: 'value',
						value:0,
						store: new Ext.data.ArrayStore({
							fields: ['display', 'value'],
							data: [
								[_S('FTP_EXPLORER','NORMAL'), 0],
								[_S('FTP_EXPLORER','EXPLICIT_OVER_TLS'), 1],									
								[_S('FTP_EXPLORER','IMPLICIT_OVER_TLS'), 2]									
							]						
						}),
						listeners:{
							select:function(combo, records, eOpts ){
								
							}
						}
					}, {
						xtype: 'displayfield',
						cls: 'ftp-setting-encryption-img',
						width: 24,
                        height: 24
					}, {
						xtype: 'combobox',
						itemId: 'add-transfer-mode',
						cls: 'ftp-setting-transfer-mode',
						fieldLabel: _S('FTP_EXPLORER', 'TRANSFER_MODE'),
						editable: false,						
						displayField:'display',
						valueField: 'value',
						value: 1,
						width: 480,
						labelWidth: 200,
						store: new Ext.data.ArrayStore({
							fields: ['display', 'value'],
							data: [
								[_S('FTP_EXPLORER','ACTIVE'), 0],
								[_S('FTP_EXPLORER','PASSIVE'), 1],
								[_S('FTP_EXPLORER','AUTO_SELECT'), 2]
							]
						}),
						listeners:{
							select:function(combo, records, eOpts ){
								
							}
						}
					}, {
						xtype: 'displayfield',
						cls: 'ftp-setting-transfer-mode-img',
						width: 24,
                        height: 24
					}, {
						xtype: 'combobox',
						itemId:'add-file-exist',
						cls: 'ftp-setting-file-exist',
						editable: false,
						width: 480,
						labelWidth: 200,
						fieldLabel: _S('FTP_EXPLORER', 'FILE_EXIST_ALREADY'),
						displayField:'display',
						valueField: 'value',
						value:0,
						store: new Ext.data.ArrayStore({
							fields: ['display', 'value'],
							data: [
								[_S('FTP_EXPLORER','SKIP'), 0],
								[_S('FTP_EXPLORER','OVERWRITE'), 1],
								[_S('FTP_EXPLORER','OVERWRITE_IF_MODIFIED'), 2]									
							]						
						}),
						listeners:{
							select:function(combo, records, eOpts ){
								
							}
						}
					}, {
						xtype: 'displayfield',
						cls: 'ftp-setting-file-exist-img',
						width: 24,
                        height: 24
					}]
				}]
			});
			var win = Ext.create('AS.ARC.subWindow', {
				title: _S('FTP_EXPLORER', 'ADD_HOST'),
				parentWin: fn.settingWin,
				width: 550,
				height: 450,
				items: [settingAddTab],
				fbar: {
					items: [{
						text: _S('COMMON', 'CONNECT'),
						disabled:true,
						handler: function () {
							win.el.mask(Ext.String.format(_S('FTP_EXPLORER','CONNECTING'),settingAddTab.items.get('setting-add-general').items.get('add-host').getValue()));
							var urlOpts = {
								act: 'connect',
								server_info: settingAddTab.items.get('setting-add-general').items.get('add-host').getValue(),
								port: settingAddTab.items.get('setting-add-general').items.get('add-port').getValue(),
								username: settingAddTab.items.get('setting-add-general').items.get('add-username').getValue(),
								password: settingAddTab.items.get('setting-add-general').items.get('add-password').getValue(),
								login_type: settingAddTab.items.get('setting-add-general').items.get('add-logintype').getValue(),
								encryption: settingAddTab.items.get('setting-add-advanced').items.get('add-encryption').getValue(),
								transfer_mode: settingAddTab.items.get('setting-add-advanced').items.get('add-transfer-mode').getValue(),
								file_existing_mode: settingAddTab.items.get('setting-add-advanced').items.get('add-file-exist').getValue()
							};
							AS.ARC.ajax({
								url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, urlOpts),
								method: 'post',
								success: function (json, opts) {
									if(typeof json !== 'undefined'){
										fn.connectpanel.items.get('disconnect').enable();
										fn.connectpanel.items.get('hostIP').setValue(settingAddTab.items.get('setting-add-general').items.get('add-host').getValue());
										fn.connectpanel.items.get('port').setValue(settingAddTab.items.get('setting-add-general').items.get('add-port').getValue());
										fn.connectpanel.items.get('username').setValue(settingAddTab.items.get('setting-add-general').items.get('add-username').getValue());
										fn.connectpanel.items.get('password').setValue(settingAddTab.items.get('setting-add-general').items.get('add-password').getValue());
										// win.close();
										fn.ftpStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act:'ftp_list',ftp_dir:''});
										fn.ftpStore.load();
										fn.ftpPanel.dockedItems.items[0].items.get('ftppath').setValue('/');
										fn.ftpHost = settingAddTab.items.get('setting-add-general').items.get('add-host').getValue();
										fn.ftpPort = settingAddTab.items.get('setting-add-general').items.get('add-port').getValue();
										var urlOpts = {
											act: 'server_add',
											site_name: settingAddTab.items.get('setting-add-general').items.get('add-sitename').getValue(),
											server_info: settingAddTab.items.get('setting-add-general').items.get('add-host').getValue(),
											port: settingAddTab.items.get('setting-add-general').items.get('add-port').getValue(),
											username: settingAddTab.items.get('setting-add-general').items.get('add-username').getValue(),
											password: settingAddTab.items.get('setting-add-general').items.get('add-password').getValue(),
											login_type: settingAddTab.items.get('setting-add-general').items.get('add-logintype').getValue(),
											encryption: settingAddTab.items.get('setting-add-advanced').items.get('add-encryption').getValue(),
											transfer_mode: settingAddTab.items.get('setting-add-advanced').items.get('add-transfer-mode').getValue(),
											file_existing_mode: settingAddTab.items.get('setting-add-advanced').items.get('add-file-exist').getValue()
										};
										win.close();
										AS.ARC.ajax({
											url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, urlOpts),
											method: 'post',
											success: function (json, opts) {													if(typeof json !== 'undefined') {
													fn.serverStore.load();
												}
											},
											failure: function (json, opts) {
												AS.ARC.util.showMsgWindow({
													5008: _S('FTP_EXPLORER','ERROR_5008'),
													5303: _S('FTP_EXPLORER','ERROR_5303'),
													5401: _S('FTP_EXPLORER','ERROR_5401'),
													5026: _S('ERROR', 'SYSTEM_READ_ONLY')
												}, json, win);
											}
										});
										fn.settingWin.close();
									}
								},
								failure: function (json, opts) {
									win.el.unmask();
									var host = settingAddTab.items.get('setting-add-general').items.get('add-host').getValue();
									//fn.ftpPanel.el.unmask();
									AS.ARC.util.showMsgWindow({
										5601: Ext.String.format(_S('FTP_EXPLORER', 'ERROR_UNABLE_CONNECT'), host),
										5026: _S('ERROR', 'SYSTEM_READ_ONLY')
									}, json, win);
								}

							});
						},
						scope: this
					},{
						text: _S('COMMON', 'SAVE'),
						disabled:true,
						handler: function () {
							var urlOpts = {
								act: 'server_add',
								site_name: settingAddTab.items.get('setting-add-general').items.get('add-sitename').getValue(),
								server_info: settingAddTab.items.get('setting-add-general').items.get('add-host').getValue(),
								port: settingAddTab.items.get('setting-add-general').items.get('add-port').getValue(),
								username: settingAddTab.items.get('setting-add-general').items.get('add-username').getValue(),
								password: settingAddTab.items.get('setting-add-general').items.get('add-password').getValue(),
								login_type: settingAddTab.items.get('setting-add-general').items.get('add-logintype').getValue(),
								encryption: settingAddTab.items.get('setting-add-advanced').items.get('add-encryption').getValue(),
								transfer_mode: settingAddTab.items.get('setting-add-advanced').items.get('add-transfer-mode').getValue(),
								file_existing_mode: settingAddTab.items.get('setting-add-advanced').items.get('add-file-exist').getValue(),
							};
							AS.ARC.ajax({
								url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, urlOpts),
								method: 'post',
								success: function (json, opts) {
									if(typeof json !== 'undefined'){
										fn.serverStore.load();
										win.close();
									}
								},
								failure: function (json, opts) {
									AS.ARC.util.showMsgWindow({
										5008: _S('FTP_EXPLORER','ERROR_5008'),
										5026: _S('ERROR', 'SYSTEM_READ_ONLY')
									}, json, win);
							
								}

							});
						},
						scope: this
					},{
						text: _S('COMMON', 'CANCEL'),
						handler: function () {
							win.close();
						},
						scope: this
					}]
				},
				listeners: {
					show: function () {
						fn.settingWin.dockedItems.items[1].items.items[0].hide();
					}
				}
			});
			win.show();
		};
		function settingEdit() {
			fn.settingMode = 'edit';
			var settingEditTab = new Ext.create('Ext.tab.Panel', {
				cls: 'app-ftp-setting-edit',
				items: [{
					title: _S('COMMON','GENERAL'),
					itemId:'setting-edit-general',
					height: 300,
					items: [
					{
						xtype: 'textfield',
						itemId:'edit-sitename',
						cls: 'ftp-setting-sitename',
						fieldLabel: _S('FTP_EXPLORER', 'SITE_NAME'),
						msgTarget: AS.ARC.config.msgTarget,
						enableKeyEvents: true,
						checkChangeBuffer: AS.ARC.config.keyBuffer,
						allowBlank: false,
						blankText: _S('MESSAGE', 'HF00011'),
						labelWidth: 200,
						width: 480,
						emptyText: _S('FTP_EXPLORER', 'SITE_NAME'),
						value: fn.serverListGrid.getSelectionModel().selected.items[0].data.site_name,						
						vtype:'settingSiteName',
						mode:'edit',
						listeners:{
							change:function(field){
								var generalItem = settingEditTab.items.get('setting-edit-general').items,
									connectBtn = win.dockedItems.items[1].items.items[0];
									saveBtn = win.dockedItems.items[1].items.items[1];
								
								if(generalItem.get('edit-sitename').getValue() !=='' && generalItem.get('edit-host').getValue() !== ''
								&& generalItem.get('edit-port').getValue() !== null && generalItem.get('edit-logintype').getValue() == 0){
									//login type = normal
                                    // && generalItem.get('edit-password').getValue() !== ''
									if(generalItem.get('edit-username').getValue() !== '' && generalItem.get('edit-port').isValid()){
										connectBtn.enable();
										saveBtn.enable();
									}else{
										connectBtn.disable();
										saveBtn.disable();
									}
								}else if(generalItem.get('edit-sitename').getValue() !=='' && generalItem.get('edit-host').getValue() !== ''
								&& generalItem.get('edit-port').getValue() !== null && generalItem.get('edit-logintype').getValue() == 1){
									connectBtn.enable();
									saveBtn.enable();
								}else{
									connectBtn.disable();
									saveBtn.disable();
								}
							}
						}
					},  {
						xtype: 'displayfield',
						cls: 'ftp-setting-sitename-img',
						width: 24,
						height: 24
					}, {
						xtype: 'textfield',
						itemId: 'edit-host',
						cls: 'ftp-setting-host',
						msgTarget: AS.ARC.config.msgTarget,
						width: 480,
						labelWidth: 200,
						emptyText: _S('FTP_EXPLORER', 'HOSTIP'),
						fieldLabel: _S('FTP_EXPLORER', 'SERVER_INFO'),
						value: fn.serverListGrid.getSelectionModel().selected.items[0].data.server_info,						
						vtype:'settingHost',
						listeners:{
							change:function(field){
								var generalItem = settingEditTab.items.get('setting-edit-general').items,
									connectBtn = win.dockedItems.items[1].items.items[0];
									saveBtn = win.dockedItems.items[1].items.items[1];
								
								if(generalItem.get('edit-sitename').getValue() !=='' && generalItem.get('edit-host').getValue() !== ''
								&& generalItem.get('edit-port').getValue() !== null && generalItem.get('edit-logintype').getValue() == 0){
									//login type = normal
                                    // && generalItem.get('edit-password').getValue() !== ''
									if(generalItem.get('edit-username').getValue() !== '' && generalItem.get('edit-port').isValid()){
										connectBtn.enable();
										saveBtn.enable();
									}else{
										connectBtn.disable();
										saveBtn.disable();
									}
								}else if(generalItem.get('edit-sitename').getValue() !=='' && generalItem.get('edit-host').getValue() !== ''
								&& generalItem.get('edit-port').getValue() !== null && generalItem.get('edit-logintype').getValue() == 1){
									connectBtn.enable();
									saveBtn.enable();
								}else{
									connectBtn.disable();
									saveBtn.disable();
								}
							}
						}
					}, {
						xtype: 'displayfield',
						cls: 'ftp-setting-host-img',
						width: 24,
                        height: 24
					},{
						xtype: 'numberfield',
						itemId:'edit-port',
						cls: 'ftp-setting-port',
						msgTarget: AS.ARC.config.msgTarget,
						width: 276,
						emptyText: _S('FTP_EXPLORER', 'Port'),
						allowDecimals:false,
						hideTrigger:false,
						maxValue: 65535,
						minValue: 1,
						value: fn.serverListGrid.getSelectionModel().selected.items[0].data.port,
						style: 'display:inline-block;position:relative;left:205px;',
						listeners:{
							change:function(field){
								var generalItem = settingEditTab.items.get('setting-edit-general').items,
									connectBtn = win.dockedItems.items[1].items.items[0];
									saveBtn = win.dockedItems.items[1].items.items[1];
								
								if(generalItem.get('edit-sitename').getValue() !=='' && generalItem.get('edit-host').getValue() !== ''
								&& generalItem.get('edit-port').getValue() !== null && generalItem.get('edit-logintype').getValue() == 0){
									//login type = normal
                                    // generalItem.get('edit-password').getValue() !== '' && 
									if(generalItem.get('edit-username').getValue() !== '' && generalItem.get('edit-port').isValid()){
										connectBtn.enable();
										saveBtn.enable();
									}else{
										connectBtn.disable();
										saveBtn.disable();
									}
								}else if(generalItem.get('edit-sitename').getValue() !=='' && generalItem.get('edit-host').getValue() !== ''
								&& generalItem.get('edit-port').getValue() !== null && generalItem.get('edit-logintype').getValue() == 1){
									connectBtn.enable();
									saveBtn.enable();
								}else{
									connectBtn.disable();
									saveBtn.disable();
								}
							}
						}
					}, {
						xtype: 'displayfield',
						cls: 'ftp-setting-port-img',
						width: 24,
                        height: 24
					}, {
						xtype: 'combobox',
						itemId:'edit-logintype',
						cls: 'ftp-setting-logintype',
						fieldLabel: _S('FTP_EXPLORER', 'LOGIN_TYPE'),
						msgTarget: AS.ARC.config.msgTarget,
						editable: false,
						width: 480,
						labelWidth: 200,
						displayField:'display',
						valueField: 'value',
						value: fn.serverListGrid.getSelectionModel().selected.items[0].data.login_type,
						store: new Ext.data.ArrayStore({
							fields: ['display', 'value'],
							data: [
								[_S('FTP_EXPLORER','NORMAL'), 0],
								[_S('FTP_EXPLORER','ANONYMOUS'), 1]									
							]						
						}),
						listeners:{
							afterrender: function(combo, eOpts) {
								if (combo.value == 1) {
									settingEditTab.items.items[0].items.get('edit-username').disable();
									// settingEditTab.items.items[0].items.get('edit-password-icon').disable();
									settingEditTab.items.items[0].items.get('edit-password').disable();
								} else {
									settingEditTab.items.items[0].items.get('edit-username').enable();
									// settingEditTab.items.items[0].items.get('edit-password-icon').enable();
									settingEditTab.items.items[0].items.get('edit-password').enable();
								}
							},
							select:function(combo, records, eOpts ){
								if(records[0].data.value == 1){
									settingEditTab.items.items[0].items.get('edit-username').disable();
									// settingEditTab.items.items[0].items.get('edit-password-icon').disable();
									settingEditTab.items.items[0].items.get('edit-password').disable();
								}else{
									settingEditTab.items.items[0].items.get('edit-username').enable();
									// settingEditTab.items.items[0].items.get('edit-password-icon').enable();
									settingEditTab.items.items[0].items.get('edit-password').enable();
								}
							},
							change:function(field){
								var generalItem = settingEditTab.items.get('setting-edit-general').items,
									connectBtn = win.dockedItems.items[1].items.items[0];
									saveBtn = win.dockedItems.items[1].items.items[1];
								
								if(generalItem.get('edit-sitename').getValue() !=='' && generalItem.get('edit-host').getValue() !== ''
								&& generalItem.get('edit-port').getValue() !== null && generalItem.get('edit-logintype').getValue() == 0){
									//login type = normal
                                    // && generalItem.get('edit-password').getValue() !== ''
									if(generalItem.get('edit-username').getValue() !== '' && generalItem.get('edit-port').isValid()){
										connectBtn.enable();
										saveBtn.enable();
									}else{
										connectBtn.disable();
										saveBtn.disable();
									}
								}else if(generalItem.get('edit-sitename').getValue() !=='' && generalItem.get('edit-host').getValue() !== ''
								&& generalItem.get('edit-port').getValue() !== null && generalItem.get('edit-logintype').getValue() == 1){
									connectBtn.enable();
									saveBtn.enable();
								}else{
									connectBtn.disable();
									saveBtn.disable();
								}
							}
						}
					}, {
						xtype: 'displayfield',
						cls: 'ftp-setting-logintype-img',
						width: 24,
                        height: 24
					},
					{
						xtype: 'textfield',
						itemId:'edit-username',
						cls: 'ftp-setting-username',
						value: fn.serverListGrid.getSelectionModel().selected.items[0].data.username,
						msgTarget: AS.ARC.config.msgTarget,
						fieldLabel: _S('FTP_EXPLORER', 'AUTHENTICATION'),
						emptyText: _S('FTP_EXPLORER', 'USERNAME'),
						width: 480,
						labelWidth: 200,
						listeners:{
							change:function(field){
								var generalItem = settingEditTab.items.get('setting-edit-general').items,
									connectBtn = win.dockedItems.items[1].items.items[0];
									saveBtn = win.dockedItems.items[1].items.items[1];

								if(generalItem.get('edit-sitename').getValue() !=='' && generalItem.get('edit-host').getValue() !== ''
								&& generalItem.get('edit-port').getValue() !== null && generalItem.get('edit-logintype').getValue() == 0){
									//login type = normal
                                    // && generalItem.get('edit-password').getValue() !== ''
									if(generalItem.get('edit-username').getValue() !== '' && generalItem.get('edit-port').isValid()){
										connectBtn.enable();
										saveBtn.enable();
									}else{
										connectBtn.disable();
										saveBtn.disable();
									}
								}else if(generalItem.get('edit-sitename').getValue() !=='' && generalItem.get('edit-host').getValue() !== ''
								&& generalItem.get('edit-port').getValue() !== null && generalItem.get('edit-logintype').getValue() == 1){
									connectBtn.enable();
									saveBtn.enable();
								}else{
									connectBtn.disable();
									saveBtn.disable();
								}
							}
						}
					}, {
						xtype: 'displayfield',
						cls: 'ftp-setting-username-img',
						width: 24,
                        height: 24
					},{
						xtype: 'textfield',
						itemId:'edit-password',
						cls: 'ftp-setting-password',
						inputType: 'password',
						msgTarget: AS.ARC.config.msgTarget,
						emptyText: _S('FTP_EXPLORER', 'PASSWORD'),
						width: 276,
						style: 'display:inline-block;position:relative;left:205px;',
						value: fn.serverListGrid.getSelectionModel().selected.items[0].data.password,
						listeners:{
							change:function(field){
								var generalItem = settingEditTab.items.get('setting-edit-general').items,
									connectBtn = win.dockedItems.items[1].items.items[0];
									saveBtn = win.dockedItems.items[1].items.items[1];
								
								if(generalItem.get('edit-sitename').getValue() !=='' && generalItem.get('edit-host').getValue() !== ''
								&& generalItem.get('edit-port').getValue() !== null && generalItem.get('edit-logintype').getValue() == 0){
									//login type = normal
                                    // && generalItem.get('edit-password').getValue() !== ''
									if(generalItem.get('edit-username').getValue() !== '' && generalItem.get('edit-port').isValid()){
										connectBtn.enable();
										saveBtn.enable();
									}else{
										connectBtn.disable();
										saveBtn.disable();
									}
								}else if(generalItem.get('edit-sitename').getValue() !=='' && generalItem.get('edit-host').getValue() !== ''
								&& generalItem.get('edit-port').getValue() !== null && generalItem.get('edit-logintype').getValue() == 1){
									connectBtn.enable();
									saveBtn.enable();
								}else{
									connectBtn.disable();
									saveBtn.disable();
								}
							}
						}
					}, {
						xtype: 'displayfield',
						itemId: 'add-password-icon',
						cls: 'ftp-setting-password-img',
						width: 24,
                        height: 24
					}]
				},{
					title: _S('COMMON','ADVANCED'),
					itemId:'setting-edit-advanced',
					height: 300,
					items: [
					{
						xtype: 'combobox',
						itemId:'edit-encryption',
						cls: 'ftp-setting-encryption',
						editable: false,
						fieldLabel: _S('FTP_EXPLORER', 'ENCRYPTION'),
						labelWidth: 200,
						width: 480,
						displayField:'display',
						valueField: 'value',
						value: fn.serverListGrid.getSelectionModel().selected.items[0].data.encryption,
						store: new Ext.data.ArrayStore({
							fields: ['display', 'value'],
							data: [
								[_S('FTP_EXPLORER','NORMAL'), 0],
								[_S('FTP_EXPLORER','EXPLICIT_OVER_TLS'), 1],									
								[_S('FTP_EXPLORER','IMPLICIT_OVER_TLS'), 2]									
							]						
						}),
						listeners:{
							select:function(combo, records, eOpts ){
								
							}
						}
					}, {
						xtype: 'displayfield',
						cls: 'ftp-setting-encryption-img',
						width: 24,
                        height: 24
					},
					{
						xtype: 'combobox',
						itemId: 'edit-transfer-mode',
						cls: 'ftp-setting-transfer-mode',
						fieldLabel: _S('FTP_EXPLORER', 'TRANSFER_MODE'),
						width: 480,
						labelWidth: 200,
						editable: false,
						displayField:'display',
						valueField: 'value',
						value: fn.serverListGrid.getSelectionModel().selected.items[0].data.transfer_mode,
						store: new Ext.data.ArrayStore({
							fields: ['display', 'value'],
							data: [
								[_S('FTP_EXPLORER','ACTIVE'), 0],
								[_S('FTP_EXPLORER','PASSIVE'), 1],
								[_S('FTP_EXPLORER','AUTO_SELECT'), 2]
							]
						}),
						listeners:{
							select:function(combo, records, eOpts ){
								
							}
						}
					}, {
						xtype: 'displayfield',
						cls: 'ftp-setting-transfer-mode-img',
						width: 24,
                        height: 24
					},
					{
						xtype: 'combobox',
						itemId: 'edit-file-exist',
						cls: 'ftp-setting-file-exist',
						width: 480,
						labelWidth: 200,
						fieldLabel: _S('FTP_EXPLORER', 'FILE_EXIST_ALREADY'),
						editable: false,						
						displayField:'display',
						valueField: 'value',
						value: fn.serverListGrid.getSelectionModel().selected.items[0].data.file_existing_mode,
						store: new Ext.data.ArrayStore({
							fields: ['display', 'value'],
							data: [
								[_S('FTP_EXPLORER','SKIP'), 0],
								[_S('FTP_EXPLORER','OVERWRITE'), 1],
								[_S('FTP_EXPLORER','OVERWRITE_IF_MODIFIED'), 2]								
							]						
						}),
						listeners:{
							select:function(combo, records, eOpts ){
								
							}
						}
					}, {
						xtype: 'displayfield',
						cls: 'ftp-setting-file-exist-img',
						width: 24,
                        height: 24
					}]
				}]
			});
			var win = Ext.create('AS.ARC.subWindow', {
				title: _S('FTP_EXPLORER', 'EDIT_HOST'),
				parentWin: fn.settingWin,
				width: 550,
				height: 450,
				items: [settingEditTab],
				fbar: {
					items: [{
						text: _S('COMMON', 'CONNECT'),
						handler: function () {
							win.el.mask(Ext.String.format(_S('FTP_EXPLORER','CONNECTING'),settingEditTab.items.get('setting-edit-general').items.get('edit-host').getValue()));
							var urlOpts = {
								act: 'connect',
								server_info: settingEditTab.items.get('setting-edit-general').items.get('edit-host').getValue(),
								port: settingEditTab.items.get('setting-edit-general').items.get('edit-port').getValue(),
								username: settingEditTab.items.get('setting-edit-general').items.get('edit-username').getValue(),
								password: settingEditTab.items.get('setting-edit-general').items.get('edit-password').getValue(),
								login_type: settingEditTab.items.get('setting-edit-general').items.get('edit-logintype').getValue(),
								encryption: settingEditTab.items.get('setting-edit-advanced').items.get('edit-encryption').getValue(),
								transfer_mode: settingEditTab.items.get('setting-edit-advanced').items.get('edit-transfer-mode').getValue(),
								file_existing_mode: settingEditTab.items.get('setting-edit-advanced').items.get('edit-file-exist').getValue()
							};
							AS.ARC.ajax({
								url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, urlOpts),
								method: 'post',
								success: function(json, opts) {
									if (typeof json !== 'undefined') {
										fn.connectpanel.items.get('disconnect').enable();
										// win.close();
										fn.connectpanel.items.get('hostIP').setValue(settingEditTab.items.get('setting-edit-general').items.get('edit-host').getValue());
										fn.connectpanel.items.get('port').setValue(settingEditTab.items.get('setting-edit-general').items.get('edit-port').getValue());
										fn.connectpanel.items.get('username').setValue(settingEditTab.items.get('setting-edit-general').items.get('edit-username').getValue());
										fn.connectpanel.items.get('password').setValue(settingEditTab.items.get('setting-edit-general').items.get('edit-password').getValue());
										fn.ftpHost = settingEditTab.items.get('setting-edit-general').items.get('edit-host').getValue();
										fn.ftpPort = settingEditTab.items.get('setting-edit-general').items.get('edit-port').getValue();
										fn.ftpStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act:'ftp_list',ftp_dir:''});
										fn.ftpStore.load();
										fn.ftpPanel.dockedItems.items[0].items.get('ftppath').setValue('/');
										fn.settingWin.close();
										var urlOpts = {
											act: 'server_set',
											id:fn.serverListGrid.getSelectionModel().selected.items[0].data.id,
											site_name: settingEditTab.items.get('setting-edit-general').items.get('edit-sitename').getValue(),
											server_info: settingEditTab.items.get('setting-edit-general').items.get('edit-host').getValue(),
											port: settingEditTab.items.get('setting-edit-general').items.get('edit-port').getValue(),
											username: settingEditTab.items.get('setting-edit-general').items.get('edit-username').getValue(),
											password: settingEditTab.items.get('setting-edit-general').items.get('edit-password').getValue(),
											login_type: settingEditTab.items.get('setting-edit-general').items.get('edit-logintype').getValue(),
											encryption: settingEditTab.items.get('setting-edit-advanced').items.get('edit-encryption').getValue(),
											transfer_mode: settingEditTab.items.get('setting-edit-advanced').items.get('edit-transfer-mode').getValue(),
											file_existing_mode: settingEditTab.items.get('setting-edit-advanced').items.get('edit-file-exist').getValue()
										};
										win.close();
										AS.ARC.ajax({
											url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, urlOpts),
											method: 'post',
											success: function (json, opts) {
												if(typeof json !== 'undefined'){
													fn.serverStore.load();
												}
											},
											failure: function (json, opts) {
												AS.ARC.util.showMsgWindow({
													5008: _S('FTP_EXPLORER','SITE_NAME_ALREADY_EXIST'),
													5303: _S('FTP_EXPLORER','ERROR_5303'),
													5401: _S('FTP_EXPLORER','ERROR_5401'),
													5026: _S('ERROR', 'SYSTEM_READ_ONLY')
												}, json, win);
											}
										});
									}
								},
								failure: function (json, opts) {
									AS.ARC.util.showMsgWindow({
										5601:Ext.String.format(_S('FTP_EXPLORER','ERROR_UNABLE_CONNECT'),settingEditTab.items.get('setting-edit-general').items.get('edit-host').getValue()),
										5026: _S('ERROR', 'SYSTEM_READ_ONLY')
									}, json, win);
								
								}

							});
						},
						scope: this
					},{
						text: _S('COMMON', 'SAVE'),
						handler: function () {
							var urlOpts = {
								act: 'server_set',
								id:fn.serverListGrid.getSelectionModel().selected.items[0].data.id,
								site_name: settingEditTab.items.get('setting-edit-general').items.get('edit-sitename').getValue(),
								server_info: settingEditTab.items.get('setting-edit-general').items.get('edit-host').getValue(),
								port: settingEditTab.items.get('setting-edit-general').items.get('edit-port').getValue(),
								username: settingEditTab.items.get('setting-edit-general').items.get('edit-username').getValue(),
								password: settingEditTab.items.get('setting-edit-general').items.get('edit-password').getValue(),
								login_type: settingEditTab.items.get('setting-edit-general').items.get('edit-logintype').getValue(),
								encryption: settingEditTab.items.get('setting-edit-advanced').items.get('edit-encryption').getValue(),
								transfer_mode: settingEditTab.items.get('setting-edit-advanced').items.get('edit-transfer-mode').getValue(),
								file_existing_mode: settingEditTab.items.get('setting-edit-advanced').items.get('edit-file-exist').getValue(),
							};
							AS.ARC.ajax({
								url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, urlOpts),
								method: 'post',
								success: function (json, opts) {
									if(typeof json !== 'undefined'){
										fn.serverStore.load();
										win.close();
									}
								},
								failure: function (json, opts) {
									AS.ARC.util.showMsgWindow({
										5008: _S('FTP_EXPLORER','ERROR_5008'),
										5026: _S('ERROR', 'SYSTEM_READ_ONLY')
									}, json, win);
									
								}

							});
						},
						scope: this
					},{
						text: _S('COMMON', 'CANCEL'),
						handler: function () {
							win.close();
						},
						scope: this
					}]
				},
				listeners: {
					show: function () {
						fn.settingWin.dockedItems.items[1].items.items[0].hide();
					}
				}
			});
			win.show();
		};
		function LocalCreateFolder(path) {
			var buttonApply = Ext.create('Ext.button.Button', {
				text: _S('COMMON', 'OK'),
				handler: function () {
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiFileExplorerUrl, {act:'createdir'}),
						method: 'post',
						params:{
							dest_path:path,
							dest_folder: win.items.items[0].items.get('nas_new_folder').getValue()
						},
						success: function (json, opts) {
							if(typeof json !== 'undefined'){
								fn.nasStore.load();
								win.close();
							}
						},
						failure: function (json, opts) {
							var notAllowOperMsg = (AS.ARC.user.isAdmin) ? _S('ERROR', 'ADMIN_NO_OBTAIN_LIST_RIGHTS') : _S('ERROR', 'USER_NO_OBTAIN_LIST_RIGHTS');
							
							AS.ARC.util.showMsgWindow({
								5008: _S('ERROR', 'UNABLE_CREATE_ALREADY_FOLDER'),
								5011: _S('ERROR', 'UNABLE_MODIFY_FILE_PROPERTIES'),
								5019: _S('ERROR', 'CANOT_CREATE_FOLDER'),
								5025: notAllowOperMsg,
								5026: _S('ERROR', 'READ_ONLY_FILE'),
								5045: _S('ERROR', 'MAXIMUN_USAGE_QUOTA'),
								5602: _S('ERROR', 'FILE_NAME_TOO_LONG') + ' (' + _S('MESSAGE', 'HF00016').replace('{0}', '' + 255) + ')',
								5605: _S('ERROR', 'NO_SPACE_DISK'),
								5634: _S('ERROR', 'FILE_NAME_TOO_LONG') + ' (' + _S('MESSAGE', 'HF00016').replace('{0}', '' + 143) + ')'
							}, json, win);
						}

					});
				},
				scope: this
			});
			
			var win = Ext.create('AS.ARC.subWindow', {
				title: _S('FTP_EXPLORER', 'CREATE_LOCAL_FOLDER'),// + '&nbsp;-&nbsp;' + _S('FTP_EXPLORER', 'LOCAL'),
				parentWin: fn.win,
				width: 400,
				height: 160,
				items: [{
					xtype: 'asPanelTop20',
					buttonApply: buttonApply,
					height:80,
					items:[{
						xtype: 'textfield',
						itemId:'nas_new_folder',
						msgTarget: 'side',
						allowBlank: false,
						blankText: _S('MESSAGE', 'HF00011'),
						labelWidth: AS.ARC.config.layout.labelWidthSmall,
						fieldLabel: _S('COMMON','FOLDER_NAME'),
						vtype: 'createFolder'
					}]
				}],
				fbar: [
					buttonApply, 
				{
					text: _S('COMMON', 'CANCEL'),
					handler: function () {
						win.close();
					},
					scope: this
				}],
				listeners:{
					show:function(win) {
						win.items.items[0].items.get('nas_new_folder').focus(true,100);
					}
				}
			});
			win.show();
		};
		function LocalRemove(path,file, total) {
			var win = new AS.ARC.msgWindow({
				title: _S('COMMON', 'CONFIRMATION'),
				parentWin: fn.win,
				iconType: 'question',
				asItems: [{
					xtype: 'displayfield',
					value: _S('FTP_EXPLORER', 'REMOVE_MSG')
				}],
				fbar: [{
					text: _S('COMMON', 'OK'),
					handler: function () {
						win.close();
						fn.nasPanel.el.mask(_S('COMMON', 'LOADING'));
                        var fileHex = '',
                            sm = fn.nasGrid.getSelectionModel(),
    						selections = sm.getSelection(),
                            fileLength = selections.length;
                        for(var i = 0; i < fileLength; i++){
                            fileHex += (fileHex == '')? '': '/';
                            fileHex += selections[i].raw.filename_hex;
                        }
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(AS.ARC.config.baseUrl + 'apis/fileExplorer/fileExplorer.cgi', {act:'delete'}),
							method: 'post',
							params:{
                                total: total,
                                file: file,
                                file_hex: fileHex,
                                path: path
							},
							success: function (json, opts) {
								AS.ARC.core.openApp('app-taskMonitor', {
									silentMode: true,
									pid: json.pid,
									handler: fn.win
								});
                            
                                var cfg = {
									url: AS.ARC.util.getApiUrlWithSid(AS.ARC.config.baseUrl + 'apis/fileExplorer/fileExplorer.cgi', 
											{act:'delete_progress'}),
									method: 'get',
									params:{
										pid: json.pid
									},
									success: function (json, opts) {
										if (json.progress != 1) AS.ARC.ajax(cfg);
										else { 
											fn.nasPanel.el.unmask();
											fn.nasStore.load();
										}
									},
									failure: function (json, opts) {
										fn.nasPanel.el.unmask();
										AS.ARC.util.showMsgWindow({
											5011: _S('ERROR', 'CANOT_DELETE_FILES'),
											5018: _S('ERROR', 'PROCESS_NOT_EXISTED'),
											5025: _S('ERROR', 'UNABLE_COMPLETELY_REMOVE_DATAS'),
											5028: _S('ERROR', 'PATH_NOT_EXISTED'),
											5029: _S('ERROR', 'DIRECTORY_NOT_EMPTY')
										}, json, fn.win);
									}
								};
                                AS.ARC.ajax(cfg);
							},
							failure: function (json, opts) {
								AS.ARC.util.showMsgWindow({
									5011: _S('FTP_EXPLORER','ERROR_5011'),
									5018: _S('FTP_EXPLORER','ERROR_5018'),
									5019: _S('FTP_EXPLORER','ERROR_5019'),
									5025: _S('FTP_EXPLORER','ERROR_5025')
								}, json, fn.win);
							}

						});
					},
					scope: this
				}, {
					text: _S('COMMON', 'CANCEL'),
					handler: function () {
						win.close();
					},
					scope: this
				}]
			});
			win.show();
		};
		function LocalRename(path,oldname) {
			var buttonApply = Ext.create('Ext.button.Button', {
				text: _S('COMMON', 'OK'),
				handler: function () {
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiFileExplorerUrl, {act:'rename'}),
						method: 'post',
						params:{
							path: path,
							current_filename: oldname,
							target_filename: win.items.items[0].items.items[0].getValue()},
						success: function (json, opts) {
							if(typeof json !== 'undefined'){
								fn.nasStore.load();
								win.close();
							}
						},
						failure: function (json, opts) {
							AS.ARC.util.showMsgWindow({
								5008: _S('ERROR', 'NEW_FILE_NAME_EXISTED'),
								5011: _S('ERROR', 'CANOT_RENAME_FILE'),
								5025: _S('ERROR', 'NO_RENAME_RIGHTS'),
								5028: _S('ERROR', 'PATH_NOT_EXISTED'),
								5602: _S('ERROR', 'FILE_NAME_TOO_LONG') + ' (' + _S('MESSAGE', 'HF00016').replace('{0}', '' + json.max_len) + ')',
							}, json, win);
						}

					});
				},
				scope: this
			});
			
			var win = Ext.create('AS.ARC.subWindow', {
				title: _S('COMMON', 'RENAME'),
				parentWin: fn.win,
				width: 400,
				height: 160,
				items: [{
					xtype: 'asPanelTop20',
					height: 80,
					buttonApply: buttonApply,
					items: [{
						xtype: 'textfield',
						labelWidth: AS.ARC.config.layout.labelWidthSmall,
						fieldLabel: _S('COMMON', 'NEW_NAME'),
						vtype: 'createFolder',
						allowBlank: false,
						value: oldname,
						msgTarget: 'side',
						blankText: _S('MESSAGE', 'HF00011'),
						maxLengthText: Ext.String.format(_S('MESSAGE', 'HF00016'), 255),
						listeners: {
							afterrender: function(field) {
								if (fn.nasGrid.getSelectionModel().selected.items[0].data.type !== 'dir') {
									win.items.items[0].items.items[0].vtype = 'createFolder'
								} else {
									win.items.items[0].items.items[0].vtype = 'createFolder'
								}
							}
						}
					}]
				}],
				fbar: [
					buttonApply, 
				{
					text: _S('COMMON', 'CANCEL'),
					handler: function () {
						win.close();
					},
					scope: this
				}]
			});
			win.show();
		};
		function FTPCreateFolder(path) {
			var buttonApply = Ext.create('Ext.button.Button', {
				text: _S('COMMON', 'OK'),
				handler: function () {
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'create_ftp_dir', new_ftp_dir: path + '/'+ win.items.items[0].items.get('newfoldername').getValue()}),
						method: 'post',
						success: function (json, opts) {
							if(typeof json !== 'undefined'){
								fn.ftpStore.load();
								win.close();
							}
						},
						failure: function (json, opts) {
							AS.ARC.util.showMsgWindow({
								5008: _S('FTP_EXPLORER','ERROR_5008'),
								5011: _S('ERROR','UNABLE_PERFORM') + _S('FTP_EXPLORER','ERROR_5011_TWO')
							}, json, win);
						}

					});
					
				},
				scope: this
			});
			
			var win = Ext.create('AS.ARC.subWindow', {
				title: _S('FTP_EXPLORER', 'CREATE_DESTINATION_FOLDER'),// + '&nbsp;-&nbsp;' + fn.ftpHost,
				parentWin: fn.win,
				width: 400,
				height: 160,
				items: [{
					xtype: 'asPanelTop20',
					buttonApply: buttonApply,
					height:80,
					items:[{
						xtype: 'textfield',
						itemId:'newfoldername',
						msgTarget: 'side',
						allowBlank: false,
						blankText: _S('MESSAGE', 'HF00011'),
						labelWidth: AS.ARC.config.layout.labelWidthSmall,
						fieldLabel: _S('COMMON','FOLDER_NAME'),
						vtype: 'createFolder'
					}]
				}],
				fbar: [
					buttonApply, 
				{
					text: _S('COMMON', 'CANCEL'),
					handler: function () {
						win.close();
					},
					scope: this
				}],
				listeners:{
					show:function(win) {
						/*if(fn.ftpHost.length > 15) {
							var first = fn.ftpHost.substr(0,6),
								last = fn.ftpHost.substr(fn.ftpHost.length-6,6);
							win.dockedItems.items[0].setTitle(_S('COMMON', 'CREATE_FOLDER') + '&nbsp;-&nbsp;' + first + '...' + last);
						}*/
						win.items.items[0].items.get('newfoldername').focus(true,100);
					}
				}
			});
			win.show();
		};
		function FTPRemove(path) {
			var win = new AS.ARC.msgWindow({
				title: _S('COMMON', 'CONFIRMATION'),
				parentWin: fn.win,
				iconType: 'question',
				asItems: [{
					xtype: 'displayfield',
					value: _S('FTP_EXPLORER', 'REMOVE_MSG')
				}],
				fbar: [{
					text: _S('COMMON', 'OK'),
					handler: function () {
						win.close();
						fn.ftpPanel.el.mask(_S('COMMON', 'LOADING'));
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'ftp_delete'}),
							timeout: 10 * 60 * 1000,
							method: 'post',
							params:{
								ftp_path: path
							},
							success: function (json, opts) {
								if (typeof json !== 'undefined') {
									fn.ftpStore.load();
									win.close();
								}
							},
							failure: function(json, opts) {
								AS.ARC.util.showMsgWindow({
									5011: _S('ERROR','UNABLE_PERFORM') + _S('FTP_EXPLORER','ERROR_5011_TWO'),
									5025: _S('FTP_EXPLORER','ERROR_5025'),
									5028: _S('FTP_EXPLORER','ERROR_5028')
								}, json, fn.win);
								fn.ftpPanel.el.unmask();
							}

						});
					},
					scope: this
				}, {
					text: _S('COMMON', 'CANCEL'),
					handler: function () {
						win.close();
					},
					scope: this
				}]
			});
			win.show();
		};
		function FTPRename(oldname) {
			var buttonApply = Ext.create('Ext.button.Button', {
				text: _S('COMMON', 'OK'),
				handler: function () {
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'ftp_rename'}),
						method: 'post',
						params:{
							ftp_old_name: fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue() + '/' + oldname,
							ftp_new_name: fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue() +'/' + win.items.items[0].items.items[0].getValue()},
						success: function (json, opts) {
							if(typeof json !== 'undefined'){
								fn.ftpStore.load();
								win.close();
							}
						},
						failure: function (json, opts) {
							AS.ARC.util.showMsgWindow({
								5011: _S('ERROR','UNABLE_PERFORM') + _S('FTP_EXPLORER','ERROR_5011_TWO'),
								5008: _S('FTP_EXPLORER','ERROR_5008')
							}, json, win);
						}

					});
				},
				scope: this
			});
			
			var win = Ext.create('AS.ARC.subWindow', {
				title: _S('COMMON', 'RENAME'),
				parentWin: fn.win,
				width: 400,
				height: 160,
				items: [{
					xtype: 'asPanelTop20',
					height: 80,
					buttonApply: buttonApply,
					items: [{
						xtype: 'textfield',
						labelWidth: AS.ARC.config.layout.labelWidthSmall,
						fieldLabel: _S('COMMON', 'NEW_NAME'),
						vtype: 'createFolder',
						allowBlank: false,
						blankText: _S('MESSAGE', 'HF00011'),
						msgTarget: 'side',
						value: oldname,
						listeners: {
							afterrender: function() {
								if (fn.ftpGrid.getSelectionModel().selected.items[0].data.type !== 'dir') {
									win.items.items[0].items.items[0].vtype = 'createFolder'
								} else {
									win.items.items[0].items.items[0].vtype = 'createFolder'
								}
							}
						}
					}]
				}],
				fbar: [
					buttonApply, 
				{
					text: _S('COMMON', 'CANCEL'),
					handler: function () {
						win.close();
					},
					scope: this
				}]
			});
			win.show();
		};
		function settingRemove() {
			var win = new AS.ARC.msgWindow({
				title: _S('COMMON', 'CONFIRMATION'),
				parentWin: fn.settingWin,
				iconType: 'question',
				asItems: [{
					xtype: 'displayfield',
					value: _S('FTP_EXPLORER', 'REMOVE_MSG')
				}],
				fbar: [{
					text: _S('COMMON', 'OK'),
					handler: function () {
						win.close();
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'server_remove'}),
						method: 'post',
						params:{id:fn.serverListGrid.getSelectionModel().selected.items[0].data.id},
						success: function (json, opts) {
							if(typeof json !== 'undefined'){
								fn.serverStore.load();
							}
						},
						failure: function (json, opts) {
							AS.ARC.util.showMsgWindow({
								5303: _S('FTP_EXPLORER','ERROR_5303'),
								5401: _S('FTP_EXPLORER','ERROR_5401')
							}, json, fn.settingWin);
						}
					});
					},
					scope: this
				}, {
					text: _S('COMMON', 'CANCEL'),
					handler: function () {
						win.close();
					},
					scope: this
				}]
			});
			win.show();
		};
		function serverList() {
			fn.serverStore = Ext.create('Ext.data.JsonStore', {
				pageSize: 8,
				autoDestroy: true,
				fields: [
					'id',
					'site_name',
					'server_info',
					'port',
					'login_type',
					'username',
					'password',
					'encryption',
					'transfer_mode',
					'file_existing_mode',
					'is_connected'
				],
				proxy: {
					type: 'ajax',
					url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act:'server_list'}),
					reader: {
						type: 'json',
						root: 'hosts',
						totalProperty: 'All'
					},
					listeners: {
						exception: function (proxy, response, operation, opts) {
							var errors = {
								5005: _S('ERROR', 'ERROR_5005')
							};

							AS.ARC.util.showMsgWindow(errors, json, fn.settingWin);
						}
					}
				},
				listeners: {										
					load: function(store, records, successful, operation, eOpts) {
						if(store.data.length > 0) {
							fn.serverListGrid.getSelectionModel().select(0);
						}
					}
				}
			});
			
			fn.serverListGrid = new Ext.create('Ext.grid.Panel', {
				store: fn.serverStore,
				height: 200,
				width: 745,
				border: true,
				// margin:'15 0 0 0',
				columns: [{
					header: _S('COMMON', 'STATUS'),
					dataIndex: 'is_connected',
					width:100,
					align: 'center',
					renderer: function(value, metaData, record, rowIndex, colIndex, store){
						if(value == 1){
							metaData.tdAttr = 'data-qtip="' +  _S('COMMON','CONNECTED') + '"';
							return '<div align="center"><img src="'+ fn.imageUrl + 'light_connect_work.png"></div>'
						}else{
							metaData.tdAttr = 'data-qtip="' +  _S('COMMON','DISCONNECTED') + '"';
							return '<div align="center"><img src="'+ fn.imageUrl + 'delight_disconnect_nowork.png" ></div>'
						}
						
					} 
				},
					{ header: _S('FTP_EXPLORER','NAME'),  dataIndex: 'site_name',width:200},
					{ header: _S('FTP_EXPLORER','HOSTIP'), dataIndex: 'server_info', flex:1 },
					{ header: _S('FTP_EXPLORER','USERNAME'), dataIndex: 'username' , width:150},
				],
				listeners:{
					itemdblclick: function () {
						settingConnect();
					},
					itemcontextmenu:function( view, record, htmlItem, rowIndex, e, eOpts ){
						var sm = fn.serverListGrid.getSelectionModel(),
							selections = sm.getSelection();
						sm.select(record);
						var rightClickMenu = new Ext.menu.Menu({
							itemId: 'menu',
							items: [{
								text: _S('COMMON', 'ADD'),
								scale: AS.ARC.config.defaultActionButtonSize,
								itemId: 'add',
								handler: function () {
									if(fn.serverListGrid.store.data.length < 16){
										settingAdd();
									}
										
								},
								scope: this
							},{
								text: _S('COMMON', 'EDIT'),
								scale: AS.ARC.config.defaultActionButtonSize,
								itemId: 'edit',
								handler: function () {
									settingEdit();
								},
								scope: this
							},{
								text: _S('COMMON', 'CONNECT'),
								scale: AS.ARC.config.defaultActionButtonSize,
								itemId: 'connect',
								handler: function () {
									settingConnect();
								},
								scope: this
							}, {
								text: _S('COMMON', 'REMOVE'),
								scale: AS.ARC.config.defaultActionButtonSize,
								itemId: 'remove',
								handler: function () {
									settingRemove();
								},
								scope: this
							}], 
							listeners: {
								hide: function (menu) {
									menu.destroy();
								}
							}
						});
					
						e.preventDefault();
						e.stopEvent();
						rightClickMenu.showAt(e.getXY());
					},
					select:function( view, record, item, index, e, eOpts ){
						serverTabPanel.items.items[0].items.get('serverBtn-edit').enable();
						serverTabPanel.items.items[0].items.get('serverBtn-connect').enable();
						serverTabPanel.items.items[0].items.get('serverBtn-remove').enable();
					}
				},
				bbar: Ext.create('AS.ARC.pagingToolbar', {
					store:fn.serverStore
				}),
			});
			
			var buttonApply = Ext.create('Ext.button.Button', {
				text: _S('COMMON', 'APPLY'),
				handler: function () {
					var generalItems = fn.settingWin.items.items[0].items.get('general').items;
					var urlOpts = {
						act: 'set_general',
						max_transfer:generalItems.get('max-simulaneous-transfer').getValue(),
						enable_max_download : generalItems.get('download-check').getValue() ? 1: 0,
						max_download : generalItems.get('download-speed').getValue(),
						enable_max_upload: generalItems.get('upload-check').getValue() ? 1: 0,
						max_upload: generalItems.get('upload-speed').getValue()
					};
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, urlOpts),
						method: 'post',
						success: function (json, opts) {
							if(typeof json !== 'undefined'){
								fn.settingWin.close();
							}
						},
						failure: function (json, opts) {
							AS.ARC.util.showMsgWindow({
								5401: _S('FTP_EXPLORER','ERROR_5401')
							}, json, fn.settingWin);
						}

					});
				},
				scope: this
			});
			
			serverTabPanel = new Ext.create('Ext.tab.Panel', {
				cls: 'app-ftp-server-list',
				items: [{
					title: _S('FTP_EXPLORER','HOST'),
					itenId:'host',
					items:[{
							xtype:'button',
							text: _S('COMMON', 'ADD'),
							itemId:'serverBtn-add',
							handler: function () {
								settingAdd();
							},
							scope: this
						},{
							xtype:'button',
							text: _S('COMMON', 'EDIT'),
							disabled:true,
							itemId:'serverBtn-edit',
							handler: function () {
								settingEdit();
							},
							scope: this
						},{
							xtype:'button',
							// margin: '20 15 0 0',
							disabled:true,
							text: _S('COMMON', 'CONNECT'),
							itemId:'serverBtn-connect',
							handler: function () {
								settingConnect();
							},
							scope: this
						},{
							xtype:'button',
							// margin: '20 15 0 0',
							disabled:true,
							text: _S('COMMON', 'REMOVE'),
							itemId:'serverBtn-remove',
							handler: function () {
								settingRemove();
							},
							scope: this
						},
						fn.serverListGrid ]
				}, {
					xtype: 'asPanelTop20',
					title: _S('COMMON','GENERAL'),
					buttonApply: buttonApply,
					itemId:'general',
					items:[{
						xtype: 'numberfield',
						itemId:'max-simulaneous-transfer',
						allowDecimals:false,
						labelWidth: AS.ARC.config.layout.labelWidthLong,
						fieldLabel: _S('FTP_EXPLORER','MAX_SIMULTANEOUS_TRANSFER'),
						value: 2,
						maxValue: 10,
						minValue: 1,
						allowBlank: false,
						blankText: _S('MESSAGE', 'HF00011'),
						negativeText: Ext.String.format(_S('MESSAGE','HF00027'), '-'),
						msgTarget: AS.ARC.config.msgTarget,
						nanText: _S('MESSAGE','HF00027'),
						maxText: _S('MESSAGE','HF00024'),
						minText: _S('MESSAGE','HF00025')
					}, {
						xtype:'checkbox',
						boxLabel: _S('FTP_EXPLORER','MAX_DOWNLOAD_SPEED'),
						itemId:'download-check',
						width:325,
						style: 'display:inline-block;',
						listeners:{
							change:function(checkbox, newValue, oldValue, eOpts){
								if(newValue) {
									serverTabPanel.items.get('general').items.get('download-speed').enable();
									serverTabPanel.items.get('general').items.get('download-speed').isValid();
								} else {
									serverTabPanel.items.get('general').items.get('download-speed').disable();
									serverTabPanel.items.get('general').items.get('download-speed').clearInvalid();
								}
							}
						}
					},{
						xtype: 'numberfield',
						itemId:'download-speed',
						disabled:true,
						allowDecimals:false,
						maxValue: 999999,
						minValue: 0,
						allowBlank: false,
						style: 'display:inline-block;',
						blankText: _S('MESSAGE', 'HF00011'),
						negativeText: Ext.String.format(_S('MESSAGE','HF00027'), '-'),
						msgTarget: AS.ARC.config.msgTarget,
						nanText: _S('MESSAGE','HF00027'),
						maxText: _S('MESSAGE','HF00024'),
						minText: _S('MESSAGE','HF00025')
					},{
						xtype: 'displayfield',
						value: 'KB/s',
						style: 'display:inline-block;',
						width: 100,
						margin: '0 0 0 10'
					},{
						xtype:'checkbox',
						boxLabel: _S('FTP_EXPLORER','MAX_UPLOAD_SPEED'),
						itemId:'upload-check',
						width:325,
						style: 'display:inline-block;',
						listeners:{
							change:function(checkbox, newValue, oldValue, eOpts){
								if(newValue) {
									serverTabPanel.items.get('general').items.get('upload-speed').enable();
									serverTabPanel.items.get('general').items.get('upload-speed').isValid();
								} else {
									serverTabPanel.items.get('general').items.get('upload-speed').disable();
									serverTabPanel.items.get('general').items.get('upload-speed').clearInvalid();
								}
							}
						}
					},{
						xtype: 'numberfield',
						itemId:'upload-speed',
						allowDecimals:false,
						disabled:true,
						maxValue: 999999,
						minValue: 0,
						allowBlank: false,
						style: 'display:inline-block;',
						blankText: _S('MESSAGE', 'HF00011'),
						negativeText: Ext.String.format(_S('MESSAGE','HF00027'), '-'),
						msgTarget: AS.ARC.config.msgTarget,
						nanText: _S('MESSAGE','HF00027'),
						maxText: _S('MESSAGE','HF00024'),
						minText: _S('MESSAGE','HF00025')
					},{
						xtype: 'displayfield',
						value: 'KB/s',
						width: 100,
						style: 'display:inline-block;',
						margin: '0 0 0 10'
					}
					, {
						xtype: 'displayfield',
						cls: 'note-string',
						value: _S('COMMON', 'NOTE') + _S('COMMON', 'COLON') + ' ' + _S('REMOTESYNC', 'BANDWIDTH_ZERO')
					}]
				}],
				listeners:{
					tabchange:function( tabPanel, newCard, oldCard, eOpts){
						if(newCard.itemId == 'general'){
							fn.settingWin.dockedItems.items[1].items.items[0].show();
						}else{
							fn.settingWin.dockedItems.items[1].items.items[0].hide();
						}
					}
				}
			});
			fn.settingWin = Ext.create('AS.ARC.subWindow', {
				title: _S('FTP_EXPLORER', 'SETTING'),
				parentWin: fn.win,
				width: 795,
				height: 420,
				items: [serverTabPanel],
				fbar: {
					items: [
						buttonApply,
					{
						text: _S('COMMON', 'CANCEL'),
						handler: function () {
							fn.settingWin.close();
						},
						scope: this
					}]
				},
				listeners: {
					show: function () {
						fn.serverStore.load();
						fn.settingWin.dockedItems.items[1].items.items[0].hide();
						var generalItems = fn.settingWin.items.items[0].items.get('general').items;
						//setValue
						AS.ARC.ajax({
							url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'get_general'}),
							method: 'post',
							success: function (json, opts) {
								if(typeof json !== 'undefined'){
									generalItems.get('max-simulaneous-transfer').setValue(json.max_transfer);
									generalItems.get('download-check').setValue(json.enable_max_downlaod);
									generalItems.get('download-speed').setValue(json.max_downlaod);
									generalItems.get('upload-check').setValue(json.enable_max_uplaod);
									generalItems.get('upload-speed').setValue(json.max_upload);
								}
							},
							failure: function (json, opts) {
								AS.ARC.util.showMsgWindow({
									5401: _S('FTP_EXPLORER','ERROR_5401')
								}, json, fn.settingWin);
							}

						});
					}
				}
			});
			fn.settingWin.show();
		};
		function failedRemove(cid) {
			var win = new AS.ARC.msgWindow({
				title: _S('COMMON', 'CONFIRMATION'),
				parentWin: fn.win,
				iconType: 'question',
				asItems: [{
					xtype: 'displayfield',
					value: _S('FTP_EXPLORER', 'REMOVE_MSG')
				}],
				fbar: [{
					text: _S('COMMON', 'OK'),
					handler: function () {
						activityRemove(cid);
						win.close();
					},
					scope: this
				}, {
					text: _S('COMMON', 'CANCEL'),
					handler: function () {
						win.close();
					},
					scope: this
				}]
			});
			win.show();
		};
		function upload(config) {
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'upload'}),
				method: 'post',
				params:{
					src: config.src,
					dst: config.dst //fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue()
				},
				success: function (json, opts) {
					if(typeof json !== 'undefined'){
						var toolbar = fn.infomationpanel.dockedItems.items[0];
						if(!fn.manualFalg) {
							if(fn.activityStore.data.length >= 0 ) {
								toolbar.items.items[5].items.get('expand').addCls('expandImg-expand');
								fn.infomationpanel.setHeight(235);
							}
						}
						fn.ftpStore.load();
					}
				},
				failure: function (json, opts) {
					AS.ARC.util.showMsgWindow({
						5008: _S('FTP_EXPLORER','ERROR_5008'),
						5011: _S('FTP_EXPLORER','ERROR_5011'),
						5019: _S('FTP_EXPLORER','ERROR_5019'),
						5025: _S('FTP_EXPLORER','ERROR_5025'),
						5026: _S('FTP_EXPLORER','ERROR_5026'),
						5605: _S('FTP_EXPLORER','ERROR_5045')
					}, json, fn.win);
				}

			});
		};
		function download(config){
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'download'}),
				method: 'post',
				params:{
					src: config.src,
					dst: config.dst
				},
				success: function (json, opts) {
					if(typeof json !== 'undefined'){
						var toolbar = fn.infomationpanel.dockedItems.items[0];
						if(!fn.manualFalg) {
							if(fn.activityStore.data.length >= 0 ) {
								toolbar.items.items[5].items.get('expand').addCls('expandImg-expand');
								fn.infomationpanel.setHeight(235);
							}
						}
						fn.nasStore.load();
					}
				},
				failure: function (json, opts) {
					AS.ARC.util.showMsgWindow({
						5008: _S('FTP_EXPLORER','ERROR_5008'),
						5011: _S('FTP_EXPLORER','ERROR_5011'),
						5025: _S('FTP_EXPLORER','ERROR_5025'),
						5028: _S('FTP_EXPLORER','ERROR_5028'),
						5026: _S('ERROR', 'SYSTEM_READ_ONLY')
					}, json, fn.win);
				}
			});
		};
		function showErrorWin(config, parenWin) {
			var events = config.events,
				errorLogs = [],
				titleStyle = 'background-color: #DDDDDD;line-height:20px;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;width:100%;padding: 0 5px;',
				contentStyle = 'background-color: white;line-height:28px;width:100%;padding: 0 5px;',
				titleTpl = '<div style="' + titleStyle + '" data-qtip="{0}">{0}</div>',
				contentTpl = '<div style="' + contentStyle + '" data-qtip="{0}">{0}</div>';
			
			Ext.each(events, function (item) {				
				if (item.filepath) {
					errorLogs.push(Ext.String.format(titleTpl, item.filepath));
				} else {
					errorLogs.push(Ext.String.format(titleTpl, _S('COMMON', 'SYSTEM')));
				}
				
				errorLogs.push(Ext.String.format(contentTpl, item.description));

			});	
			
			var win = Ext.create('AS.ARC.subWindow', {
				parentWin: parenWin || fn.win,
				title: _S('FTP_EXPLORER', 'LOG'),
				width: 550,
				height: 300,
				layout:'fit',
				items: [{
					xtype: 'asPanelTop10',
					autoScroll: true,
					html: '<div style="border: 1px solid #CCC;">' + errorLogs.join(' ') + '</div>'
				}],
				fbar: {
					items: [{
						text: _S('COMMON', 'CLOSE'),
						handler: function () {
							win.close()
						},
						scope: this
					}]
				}
			});
			win.show();
		};
		function showDetailWin(config) {
			var failedFiles = '',
				failTpl = '<div data-qtip="{0}">{1}{2}</div>';

			var status = [_S('COMMON', 'SUCCESS'), _S('COMMON', 'WARNING'), _S('COMMON', 'ERROR')];
			var source = config.source.splice(','),
				dataSource = '';

			source.forEach(function(data){
				dataSource += (dataSource.length == 0) ? '' : '<br>';
				dataSource += data
			});

			var data = [{
				name: _S('COMMON', 'NAME'),
				value: config.name
			}, {
				name: _S('FTP_EXPLORER', 'SERVER_ADDR'),
				value: config.server_address
			}, {
				name: _S('FTP_EXPLORER', 'TRANSFER_MODE'),
				value: (config.transfer_mode == 1 ? _S('COMMON', 'UPLOAD') : _S('COMMON', 'DOWNLOAD'))
			}, {
				name: _S('FTP_EXPLORER', 'SOURCE'),
				value: dataSource
			}, {
				name: _S('FTP_EXPLORER', 'DESTINATION'),
				value: config.destination
			}, {
				name: _S('FTP_EXPLORER', 'SIZE'),
				value: AS.ARC.util.convertSizeUnit(config.total_size)
			}, {
				name: _S('FTP_EXPLORER', 'SPEED'),
				value: AS.ARC.util.convertSizeUnit(config.speed) + '/s'
			}, {
				name: _S('FTP_EXPLORER', 'START_TIME'),
				value: config.start_time
			}, {
				name: _S('FTP_EXPLORER', 'ELAPSED_TIME'),
				value: AS.ARC.util.convertTime(config.elapsed_time)
			}, {
				name: _S('COMMON', 'STATUS'),
				value: status[config.status]
			}];
			
			var gridDetail = Ext.create('Ext.grid.Panel', {
				border: false,
				store: Ext.create('Ext.data.Store', {
					fields: ['name','value'],
					data: data
				}),
				columns: [{
					text: _S('COMMON', 'NAME'),
					flex: 2,
					sortable: false,
					dataIndex: 'name'
				}, {
					text: _S('COMMON', 'VALUE'),
					flex: 5,
					sortable: false,
					dataIndex: 'value',
					renderer: function (value, metadata, record, index) {
						var displayColumns = [_S('COMMON', 'NAME'), _S('FTP_EXPLORER', 'SERVER_ADDR'),
												_S('FTP_EXPLORER', 'DESTINATION')]; 
						if (displayColumns.indexOf(record.data.name) !== -1) {
							metadata.tdAttr = 'data-qtip="' + value + '"';

						} else if (record.data.name === _S('COMMON', 'STATUS')) {

							var id = Ext.id(),
								tpl = '<div id="' + id + '" style="cursor:pointer;text-decoration:underline;color:{0}">{1}</div>';				
							if (value === _S('COMMON', 'SUCCESS')) {
								return _S('COMMON', 'SUCCESS');

							} else if (value === _S('COMMON', 'WARNING')) {
								Ext.defer(function () {
									Ext.get(id).on('click', function (el) {
										showErrorWin(config, win);
									});
								}, 1);
								return Ext.String.format(tpl, 'blue', _S('COMMON', 'WARNING'));

							} else if (value === _S('COMMON', 'ERROR')) {
								Ext.defer(function () {
									Ext.get(id).on('click', function (el) {
										showErrorWin(config, win);
									});
								}, 1);
								return Ext.String.format(tpl, 'red', _S('COMMON', 'ERROR'));
							}
						}

						return value;
					}
				}]
			});
			var win = Ext.create('AS.ARC.subWindow', {
				title: _S('COMMON', 'INFORMATION'),
				parentWin: fn.win,
				width: 600,
				height: 500,
				layout:'fit',
				items: [{
					xtype: 'asPanelTop10',
					items: [gridDetail]
				}],
				fbar: {
					items: [{
						text: _S('COMMON', 'CLOSE'),
						handler: function () {
							win.close()
						},
						scope: this
					}]
				},
				listeners: {
					show: function () {

					}
				}
			});
			win.show();
		};
		function getDetail(config, isError) {
			fn.win.el.mask(_S('COMMON', 'LOADING') + '...');
			
			AS.ARC.ajax({
				url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act: 'activity_info'}),
				params: {
					cid: config.cid
				},
				method: 'post',
				success: function (json, opts) {
					fn.win.el.unmask();
					isError ? showErrorWin(json.info) : showDetailWin(json.info);
				},
				failure: function (json, opts) {
					fn.win.el.unmask();
					AS.ARC.util.showMsgWindow({}, json, fn.win);
				}
			});
		};
		fn.connectpanel = new Ext.panel.Panel({
			border: false,
			region: 'north',
            xtype: 'asPanelToolbarTop',
            height: 40,
            cls: 'connectpanel',
			dock: 'top',
			layout: 'hbox',
			items: [{
                xtype: 'container',
                cls: 'hostImg'
            },{
                xtype: 'textfield',
                itemId: 'hostIP',
                cls: 'hostIP-text',
                width: 215,
                emptyText : _S('FTP_EXPLORER','HOSTIP'),
                listeners: {
                    change: function (me, newValue) {
                        if (newValue != '') {
                            me.up().up().items.items[0].items.get('connect').enable();
                        } else {
                            me.up().up().items.items[0].items.get('connect').disable();
                        }
                    },
                    specialkey: function(field, e){
                        // e.HOME, e.END, e.PAGE_UP, e.PAGE_DOWN,
                        // e.TAB, e.ESC, arrow keys: e.LEFT, e.RIGHT, e.UP, e.DOWN
                        if (e.getKey() == e.ENTER) {
                            if(fn.ftpHost !== ''){
                                relink();
                            }else{
                                mainConnect();
                            }
                        }
                    }
                }
            },{
                xtype: 'container',
                cls: 'usernameImg'
            },{
                xtype: 'textfield',
                itemId: 'username',
                cls: 'name-text',
                emptyText : _S('FTP_EXPLORER','USERNAME'),
                width: 155,
                listeners:{
                    specialkey: function(field, e) {
                        // e.HOME, e.END, e.PAGE_UP, e.PAGE_DOWN,
                        // e.TAB, e.ESC, arrow keys: e.LEFT, e.RIGHT, e.UP, e.DOWN
                        if (e.getKey() == e.ENTER) {
                            if (fn.ftpHost !== '') {
                                relink();
                            } else {
                                mainConnect();
                            }
                        }
                    }
                }
            },{
                xtype: 'container',
                cls: 'passwordImg'
            },{
                xtype: 'textfield',
                itemId: 'password',
                cls: 'password-text',
                inputType: 'password',
                emptyText : _S('FTP_EXPLORER','PASSWORD'),
                width: 155,
                listeners:{
                    specialkey: function(field, e) {
                        // e.HOME, e.END, e.PAGE_UP, e.PAGE_DOWN,
                        // e.TAB, e.ESC, arrow keys: e.LEFT, e.RIGHT, e.UP, e.DOWN
                        if (e.getKey() == e.ENTER) {
                            if (fn.ftpHost !== '') {
                                relink();
                            } else {
                                mainConnect();
                            }
                        }
                    }
                }
            }, {
                xtype: 'container',
                cls: 'portImg'
            }, {
            	xtype: 'numberfield',
            	itemId: 'port',
            	cls: 'port-text',
            	hideTrigger: true,
            	allowDecimals: false,
            	width: 105,
            	value: 21,
            	emptyText: _S('FTP_EXPLORER', 'Port'),
            	listeners: {
            		specialkey: function(field, e) {
            			// e.HOME, e.END, e.PAGE_UP, e.PAGE_DOWN,
            			// e.TAB, e.ESC, arrow keys: e.LEFT, e.RIGHT, e.UP, e.DOWN
            			if (e.getKey() == e.ENTER) {
            				if (fn.ftpHost !== '') {
            					relink();
            				} else {
            					mainConnect();
            				}
            			}
            		}
            	}
            }, {
				xtype: 'button',
				itemId: 'connect',
                text: _S('COMMON', 'CONNECT'),
                cls: 'connect-btn',
				disabled: true,
				width: 100,
				height: 28,
				listeners: {
					render: function( me, eOpts ) {
						Ext.fly(this.el).on('click', function (e, t) {
							if (me.disabled) return;
							
							if(isConnected()){
								relink();
							}else{
								mainConnect();
							}
						});
					}
				}
			},{
				xtype: 'button',
				itemId: 'disconnect',
                cls: 'disconnect-btn',
				disabled: true,
                text: _S('COMMON', 'DISCONNECT'),
				width: 100,
				height: 28,
				listeners: {
					render: function( me, eOpts ) {
						me.el.dom.setAttribute('data-qtip', _S('COMMON', 'DISCONNECT'));
						
						Ext.fly(this.el).on('click', function (e, t) {
							if (me.disabled) return;
							if (isConnected()) {
								disconnect();
							}
							
						});
					}
				}
			},{
				xtype: 'container',
				height: 39
			},{
				xtype: 'container',
				itemId: 'setting',
				cls: 'settingsImg',
				listeners: {
					render: function( img, eOpts ) {
						img.el.dom.setAttribute('data-qtip', _S('COMMON', 'SETTINGS'));
						Ext.fly(this.el).on('click', function(e, t) {
							serverList();
						});	
					}
				}
			}]
		});
		fn.activityStore = Ext.create('Ext.data.JsonStore', {
			fields:['cid', 'direction','name', 'speed','eta','progress','server', 'state', 'total_size'],
			proxy: {
				type: 'ajax',
				url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act:'activity_list',activity_tag:'active_list'}),
				reader: {
					type: 'json',
					root: 'items'
				},
				listeners: {
					exception: function(proxy, response, operation, opts) {
						// clearTimeout(fn.activityID);
						fn.activityStore.load();
						AS.ARC.util.showMsgWindow({
						
						}, Ext.JSON.decode(response.responseText), fn.win);
					}
				}
			},
			listeners: {
				beforeload: function(store, options, eOpts) {
					if (typeof(fn.activityGrid) !== 'undefined') {
						var selections =  fn.activityGrid.getSelectionModel().getSelection();
						fn.selections = selections;
					}
				},
				load: function(store, records, successful, operation, eOpts) {
					var toolbar = fn.infomationpanel.dockedItems.items[0];
					var activityTaskDLSpeed = 0,
						activityTaskULSpeed = 0;
					if (fn.init) {
						fn.init = false;
						if (store.data.length > 0) {
							toolbar.items.items[5].items.get('expand').addCls('expandImg-expand');
							fn.infomationpanel.setHeight(235);
						}
					}
					if (typeof fn.successCount == 'undefined' || typeof fn.failedCount == 'undefined') {
						fn.successCount = store.proxy.reader.jsonData.summary.success;
						fn.failedCount = store.proxy.reader.jsonData.summary.failed;
					} else {
						fn.resultStore.load();

						if (fn.successCount !== store.proxy.reader.jsonData.summary.success) {
							fn.successCount = store.proxy.reader.jsonData.summary.success;
							fn.ftpStore.load();
							fn.nasStore.load();
						}
						if (fn.failedCount !== store.proxy.reader.jsonData.summary.failed) {
							fn.failedCount = store.proxy.reader.jsonData.summary.failed;
						}
					};
					if (records.length > 0) {
						records.forEach(function (taskSpeed) {
							if (taskSpeed.data.direction == 'upload') {
								activityTaskULSpeed = activityTaskULSpeed + taskSpeed.data.speed;
							}
							if (taskSpeed.data.direction == 'download') {
								activityTaskDLSpeed = activityTaskDLSpeed + taskSpeed.data.speed;
							}
						})
					}
					if (activityTaskDLSpeed === -1) {
                        fn.infomationpanel.dockedItems.items[0].items.get('download-info').setValue(_S('FTP_EXPLORER', 'PROCESSING'));
                    } else {
                        fn.infomationpanel.dockedItems.items[0].items.get('download-info').setValue(AS.ARC.util.convertSizeUnit(activityTaskDLSpeed) + '/s');
                    }
					if (activityTaskULSpeed === -1) {
                        fn.infomationpanel.dockedItems.items[0].items.get('upload-info').setValue(_S('FTP_EXPLORER', 'PROCESSING'));
                    } else {
                        fn.infomationpanel.dockedItems.items[0].items.get('upload-info').setValue(AS.ARC.util.convertSizeUnit(activityTaskULSpeed) + '/s');
                    }
					fn.infomationpanel.dockedItems.items[0].items.get('queue-info').setValue(store.proxy.reader.jsonData.summary.queue);
					fn.infomationpanel.dockedItems.items[0].items.get('failed-info').setValue(store.proxy.reader.jsonData.summary.failed);
					fn.activityID = setTimeout(function(){
						fn.activityStore.load();
					},3000);
	
					var sm = fn.activityGrid.getSelectionModel(),
					selected = [];
					fn.selections.forEach(function (element) {
						store.each(function (record) {
							if (record.data.cid == element.data.cid) {
								selected.push(record);
							}
						});
					});
					sm.select(selected);
				}
			}
		});
		fn.activityGrid = Ext.create('Ext.grid.Panel', {
			store: fn.activityStore,
			height:155,
            autoScroll: true,
			multiSelect: true,
			columns: [{
				header: _S('FTP_EXPLORER','NAME'),  
				dataIndex: 'name',
				flex:1,
				renderer: function(value, metaData, record, rowIndex, colIndex, store) {
					
					metaData.tdAttr = 'data-qtip="' + value + '"';
					return value
				} 
			}, {
				header: _S('FTP_EXPLORER','SPEED'), 
				dataIndex: 'speed',
				width:120,
				renderer: function(value, metaData, record, rowIndex, colIndex, store) {
					var icon = '';
                    if (value === -1) {
                        icon = _S('FTP_EXPLORER', 'PROCESSING');
                        metaData.tdAttr = 'data-qtip="' + _S('FTP_EXPLORER', 'PROCESSING') + '"';
                    } else {
                        if (record.data.direction.toLowerCase() == 'upload') {
    						switch(record.data.state) {
    							case 0: //inqueue
    								icon = '<img src="'+ fn.imageUrl + 'inqueue.png" style="width:20px; height:20px; float: left; margin-top:0px; margin-left:2px;" >&nbsp;<span style="margin-top: -4px;">&nbsp; '+ AS.ARC.util.convertSizeUnit(value) + '/s' +'</span>';
    								break;
    							case 1: //progress
    								icon = '<img src="'+ fn.imageUrl + 'upload.png" style="width:20px; height:20px; float: left; margin-top:0px; margin-left:2px;" >&nbsp;<span style="margin-top: -4px;">&nbsp; '+ AS.ARC.util.convertSizeUnit(value) + '/s' +'</span>';
    								break;
    							case 2: //aborted
    								icon = '<img src="'+ fn.imageUrl + 'pause.png" style="width:20px; height:20px; float: left; margin-top:0px; margin-left:2px;" >&nbsp;<span style="margin-top: -4px;">&nbsp; '+ AS.ARC.util.convertSizeUnit(value) + '/s' +'</span>';
    								break;
    						}
    					} else {
    						switch(record.data.state) {
    							case 0: //inqueue
    								icon = '<img src="'+ fn.imageUrl + 'inqueue.png" style="width:20px; height:20px; float: left; margin-top:0px; margin-left:2px;" >&nbsp;<span style="margin-top: -4px;">&nbsp; '+ AS.ARC.util.convertSizeUnit(value) + '/s' +'</span>';
    								break;
    							case 1: //progress
    								icon = '<img src="'+ fn.imageUrl + 'download.png" style="width:20px; height:20px; float: left; margin-top:0px; margin-left:2px;" >&nbsp;<span style="margin-top: -4px;">&nbsp; '+ AS.ARC.util.convertSizeUnit(value) + '/s' +'</span>';
    								break;
    							case 2: //aborted
    								icon = '<img src="'+ fn.imageUrl + 'pause.png" style="width:20px; height:20px; float: left; margin-top:0px; margin-left:2px;" >&nbsp;<span style="margin-top: -4px;">&nbsp; '+ AS.ARC.util.convertSizeUnit(value) + '/s' +'</span>';
    								break;
    						}
    					}
                        metaData.tdAttr = 'data-qtip="' + AS.ARC.util.convertSizeUnit(value) + '/s' + '"';
                    }
					return icon
					
				}
			}, { 
				header: _S('COMMON', 'SIZE'), 
				dataIndex: 'total_size',
				width:100,
				renderer: function(value) {
					return AS.ARC.util.convertSizeUnit(value);
				}
			}, { 
				header: _S('FTP_EXPLORER','ETA'), 
				dataIndex: 'eta',
				width:100,
				renderer: function(value, metaData, record, rowIndex, colIndex, store) {
					if (value != -1) {
						metaData.tdAttr = 'data-qtip="' + AS.ARC.util.convertTime(value) + '"';
						return AS.ARC.util.convertTime(value)
					} else {
						metaData.tdAttr = 'data-qtip="' + _S('COMMON','CACULATING') + '"';
						return _S('COMMON','CACULATING')
					}
				} 
			}, { 
				header: _S('FTP_EXPLORER','SERVER_ADDR'), 
				dataIndex: 'server' ,
				width:180,
			}, { 
				header: _S('FTP_EXPLORER','PROGRESS'), 
				dataIndex: 'progress',
				width:230,
				renderer: AS.ARC.util.renderProgress
			}],
			listeners: {
				itemdblclick: function(view, record, item, index, e, eOpts) {
					activityInfo(record.data.cid);
				},
				itemcontextmenu: function(view, record, htmlItem, rowIndex, e, eOpts) {
					var sm = fn.activityGrid.getSelectionModel(),
						selections = sm.getSelection();
					
					var rightClickMenu = new Ext.menu.Menu({
						itemId: 'activity-menu',
						items: [{
							text: (record.data.state == 2) ? _S('COMMON', 'START') : _S('COMMON', 'STOP'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'activity-queue',
							handler: function() {
                                var selectionCid = '';
								for (var i = 0; i<selections.length ; i++) {
									selectionCid += selectionCid == '' ? '' : ',';
									selectionCid += selections[i].data.cid ;
								}
								activityQueue(selectionCid);
							},
							scope: this
						}, {
							text: _S('COMMON', 'REMOVE'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'activity-remove',
							handler: function() {
								var selectionCid = '';
								for (var i = 0; i<selections.length ; i++) {
									selectionCid += selectionCid == '' ? '' : '|||';
									selectionCid += selections[i].data.cid ;
								}
								activityRemove(selectionCid);
							},
							scope: this
						}, {
							text: _S('FTP_EXPLORER', 'SELECT_ALLPAGE_ITEMS'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'activity-selectall',
							handler: function() {
								sm.selectAll();
							},
							scope: this
						}, {
							text: _S('COMMON', 'INFORMATION'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'activity-info',
							handler: function() {
								activityInfo(record.data.cid);
							},
							scope: this
						}], 
						listeners: {
							hide: function(menu) {
								menu.destroy();
							}
						}
					});
				
					e.preventDefault();
					e.stopEvent();
					rightClickMenu.showAt(e.getXY());
					if (selections.length > 1) {
						rightClickMenu.items.get('activity-info').disable();
					}
				},
			}
		});
		
		fn.activityStore.load();
		
		fn.resultStore = Ext.create('Ext.data.JsonStore', {
			fields:['cid', 'direction','name', 'total_size', 'result', 'server'],
			proxy: {
				type: 'ajax',
				url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {
					act:'activity_list',
					activity_tag:'finished_list'
				}),
				reader: {
					type: 'json',
					root: 'items',
					totalProperty: 'All'
				},
				listeners: {
					exception: function (proxy, response, operation, opts) {
						AS.ARC.util.showMsgWindow({}, Ext.JSON.decode(response.responseText), fn.win);
					}
				}
			},
			listeners: {										
				load: function(store, records, successful, operation, eOpts) {
					var sm = fn.resultGrid.getSelectionModel(),
						select = [];
						
					fn.resultGrid.selections.forEach(function (element) {
						store.each(function (record) {
							if (record.data.cid == element.data.cid) {
								select.push(record);
							}
						});
					});
					
					sm.select(select);
				}
			}
		});
		
		fn.resultGrid = Ext.create('Ext.grid.Panel', {
			store: fn.resultStore,
			height:155,
            autoScroll: true,
			multiSelect: true,
			selections: [], 
			columns: [{ 
				header: _S('FTP_EXPLORER','FILE'),  
				dataIndex: 'name', 
				flex:1
			},{ 
				header: _S('COMMON','SIZE'), 
				dataIndex: 'total_size',
				align: 'right',
				width:150,
				renderer: function(value, metaData, record, rowIndex, colIndex, store){
					metaData.tdAttr = 'data-qtip="' + AS.ARC.util.convertSizeUnit(value) + '"';
					return AS.ARC.util.convertSizeUnit(value);
				}
			}, { 
				header: _S('FTP_EXPLORER','SERVER_ADDR'),
				align: 'center',
				dataIndex: 'server' ,
				width:200
			}, {
				header: _S('COMMON','STATUS'), 
				dataIndex: 'result' ,
				align: 'center',
				width:200,
				renderer: function (value, metaData, record) {
					var id = Ext.id(),
						tpl = '<div id="' + id + '" style="cursor:pointer;text-decoration:underline;color:{0}">{1}</div>';
						
					var config = {
						cid: record.data.cid,
						direction: record.data.direction,
						name: record.data.name,
						total_size: record.data.total_size,
						result: record.data.result,
						server: record.data.server
					}
					
					if (value === 'ok') {
						return _S('COMMON', 'SUCCESS');
						
					} else if (value === 'warning') {
						Ext.defer(function () {
							Ext.get(id).on('click', function (el) {
								getDetail(config, true);
							});
						}, 1);
						return Ext.String.format(tpl, 'blue', _S('COMMON', 'WARNING'));
						
					} else if (value === 'error') {
						Ext.defer(function () {
							Ext.get(id).on('click', function (el) {
								getDetail(config, true);
							});
						}, 1);
						return Ext.String.format(tpl, 'red', _S('COMMON', 'ERROR'));
						
					} else {
						return '';
					}
				}
			}],
			listeners:{
				itemcontextmenu:function( view, record, htmlItem, rowIndex, e, eOpts ){
					var sm = fn.resultGrid.getSelectionModel(),
						selections = sm.getSelection();
					
					var rightClickMenu = new Ext.menu.Menu({
						itemId: 'menu',
						items: [{
							text: _S('FTP_EXPLORER', 'RESTART'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'restart',
							handler: function () {
								restart(selections[0].data.cid);
							},
							scope: this
						},{
							text: _S('FTP_EXPLORER', 'DETAIL'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'detail',
							handler: function () {
								getDetail({
									cid: selections[0].data.cid,
									direction: selections[0].data.direction,
									name: selections[0].data.name,
									total_size: selections[0].data.total_size,
									result: selections[0].data.result,
									server: selections[0].data.server
								});
							},
							scope: this
						},{
							text: _S('COMMON', 'REMOVE'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'remove',
							handler: function () {
								var selectionCid = '';
								for(var i = 0; i<selections.length ; i++){
									selectionCid += selectionCid == '' ? '' : '|||';
									selectionCid += selections[i].data.cid ;
								}
								failedRemove(selectionCid);
							},
							scope: this
						},{
							text: _S('FTP_EXPLORER', 'SELECT_ALLPAGE_ITEMS'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'selectall',
							handler: function () {
								sm.selectAll();
							},
							scope: this
						}], 
						listeners: {
							hide: function (menu) {
								menu.destroy();
							}
						}
					});
				
					e.preventDefault();
					e.stopEvent();
					rightClickMenu.showAt(e.getXY());
					
					if (selections.length <= 1 || selections.indexOf(record) == -1) {
						sm.select(rowIndex);
						selections = sm.getSelection();
					}
					
					if (selections.length > 1) {
						rightClickMenu.items.get('detail').disable();
						rightClickMenu.items.get('restart').disable();
					}
				},
				selectionchange: function (me, selections) {
					if (selections.length > 0) {
						fn.resultGrid.selections = selections;
					}
				}
			}
		});
		
		fn.infomationTabPanel = Ext.create('Ext.tab.Panel', {
            cls: 'infotabpanel',
			items: [{
				title: _S('FTP_EXPLORER','ACTIVITY'),
				itemId:'activity',
				xtype: 'form',
				items:[
					fn.activityGrid 
				]
			}, {
				title: _S('FTP_EXPLORER','RESULT'),
				itemId:'result',
				xtype: 'form',
				items:[
					fn.resultGrid
				]
			}],
			listeners:{
				tabchange:function( tabPanel, newCard, oldCard, eOpts ){
					if(newCard.itemId == 'result'){
						fn.resultStore.load();
					}
				}
			}
		});
		fn.infomationpanel = new Ext.panel.Panel({
			border: false,
			height: 30,
			region: 'south',
			cls: 'infopanel-outer',
			dockedItems: [{
				xtype: 'panel',
				dock: 'top',
				border: false,
				height: 30,
				layout:'hbox',
                cls: 'infopanel',
				items: [
				{
					xtype: 'displayfield',
					itemId:'download-info',
					fieldLabel: '<b>'+ _S('COMMON', 'DOWNLOAD') + '</b>',
					labelWidth: AS.ARC.config.layout.labelWidthSmall-40,
					value: '--',
					width: AS.ARC.config.layout.labelWidthSmall + 40
				},
				{
					xtype: 'displayfield',
					itemId:'upload-info',
					fieldLabel: '<b>'+ _S('COMMON', 'UPLOAD') + '</b>',
					value: '--',
					labelWidth: AS.ARC.config.layout.labelWidthSmall-40,
					width: AS.ARC.config.layout.labelWidthSmall + 40
				},
				{
					xtype: 'displayfield',
					itemId:'queue-info',
					fieldLabel: '<b>'+ _S('FTP_EXPLORER', 'QUEUE') + '</b>',
					value: '--',
					labelWidth: AS.ARC.config.layout.labelWidthSmall-40,
					width: AS.ARC.config.layout.labelWidthSmall
				},
				{
					xtype: 'displayfield',
					itemId:'failed-info',
					fieldLabel: '<b>'+ _S('COMMON', 'FAILED') + '</b>',
					value: '--',
					labelWidth: AS.ARC.config.layout.labelWidthSmall-40,
					width: AS.ARC.config.layout.labelWidthSmall
				},
				{
					xtype: 'tbfill',
				},{
					xtype: 'container',
                    width: 45,
                    cls: 'expandContainer',
                    items: {
                        xtype: 'container',
                        itemId: 'expand',
                        cls: 'expandImg'
                    }
				}],
				listeners:{
					afterrender: function( toolbar, eOpts ) {
						Ext.fly(this.el).on('click', function(e, t) {
							fn.manualFalg = true;
							if(fn.infomationpanel.getHeight() === 30){
								toolbar.items.items[5].items.get('expand').addCls('expandImg-expand');
								fn.infomationpanel.setHeight(235);
							}else{
								toolbar.items.items[5].items.get('expand').removeCls('expandImg-expand');
								fn.infomationpanel.setHeight(30);
							}
						});
					}
				}
			}],
			items:[
				fn.infomationTabPanel
			]
		});
		fn.nasStore = Ext.create('Ext.data.JsonStore', {
			autoLoad:true,
			pageSize:fn.nasPageSize,
			autoDestroy: true,
			remoteSort: true,
			fields: [
				'filename',
				'extension_type',
                'is_dir',
				'filesize',
                'file_size',
				'modify_time',
				'file_path',
				'filetype',
                'mt'
			],
			proxy: {
				type: 'ajax',
				url: AS.ARC.util.getApiUrlWithSid(fn.apiFileExplorerUrl,{act:'file_list',path:''}), // TODO
				reader: {
					type: 'json',
					root: 'data',
					totalProperty: 'all'
				},
				actionMethods: {
					create: 'POST', read: 'POST', update: 'POST', destroy: 'POST'
				},
				simpleSortMode: true,
				directionParam: 'dirway',
				sortParam: 'sortway',
				listeners: {
					exception: function (proxy, response, operation, opts) {
						fn.nasPanel.el.unmask();
						var cb = function () {
							if (Ext.JSON.decode(response.responseText).error_code === 5026) {
								fn.win.close();
							}
						}
						var errors = {
							5005: _S('FTP_EXPLORER', 'ERROR_5005'),
							5025: _S('FTP_EXPLORER', 'ERROR_5025'),
							5028: _S('FTP_EXPLORER', 'ERROR_5028'),
							5026: _S('ERROR', 'SYSTEM_READ_ONLY')
						};

						Ext.defer(function (){
							AS.ARC.util.showMsgWindow(errors, Ext.JSON.decode(response.responseText), fn.win, 'warning', cb);
						}, 300);
					}
				}
			},
			listeners:{
                beforeload:function(store, operation){
					if (operation.sorters[0]) {
						operation.sorters[0].direction = operation.sorters[0].direction.toLowerCase();
					}
					
					if(typeof (fn.nasPanel !== 'undefined')){
						fn.nasPanel.el.mask(_S('COMMON', 'LOADING'));
					}
				},
				load:function(store, node, records){
                    var rawData = store.getProxy().getReader().rawData.all;
                    if(rawData === -1) {
                        store.totalCount = store.getProxy().getReader().rawData.data.length;
                    }
                    fn.nasPanel.el.unmask();
                }
			}
		});
        
        var pagingBar = Ext.create('AS.ARC.pagingToolbar', {
            emptyMsg: _S('COMMON','EMPTY_NO_DATA'),
            dock: 'bottom',
            border: false,
            displayInfo: true,
            store: fn.nasStore
        });
                
		fn.nasGrid = new Ext.create('Ext.grid.Panel', {
			store: fn.nasStore,
			multiSelect: true,
            autoScroll: true,
			margin:'0 0 0 0',
			columns: [{
				header: _S('FTP_EXPLORER','NAME'),
				dataIndex: 'filename',
				flex:1,
				renderer: function(value, metaData, record, rowIndex, colIndex, store){
					var icon  = '';
					if (record.data.is_dir === 1) {
						icon = '<img src="'+ fn.imageUrl + 'fileicon/folder_close.png" class="grid-folder-img">&nbsp;<span style="margin-top: -4px;">&nbsp; '+ value +'</span>';
					}else{
						for(var i=0; i < fn.typearray.length; i++){
							if(record.data.extension_type == fn.typearray[i]){
								icon = '<img src="'+ fn.imageUrl + 'fileicon/'+ fn.typeUrl[i]+'" class="grid-folder-img" >&nbsp;<span style="margin-top: -4px;">&nbsp; '+ value +'</span>';
								break;
							}else{
								icon = '<img src="'+ fn.imageUrl + 'fileicon/unknow.png" class="grid-folder-img" >&nbsp;<span style="margin-top: -4px;">&nbsp; '+ value +'</span>';
							}
						}
					}
					metaData.tdAttr = 'data-qtip="' + value + '"';
					return icon
				},
				toggleSortState: function () {
					var me = this, idx, nextIdx,
						nasPath = fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue();
					
					if (me.sortable) {
						// if (nasPath === '/') {
						// 	return;
						// }
						idx = Ext.Array.indexOf(me.possibleSortStates, me.sortState);
						nextIdx = (idx + 1) % me.possibleSortStates.length;
						me.setSortState(me.possibleSortStates[nextIdx]);
					}
				}
			},{ 
				header: _S('FTP_EXPLORER','TYPE'), 
				dataIndex: 'filetype',
				width: 90,
				renderer: function(value, metaData, record, rowIndex, colIndex, store){
					if (record.data.is_dir === 1) {
						value = 'dir';
					} else {
						value = record.data.extension_type;
					}
					metaData.tdAttr = 'data-qtip="' + value + '"';
					return value;
				},
				toggleSortState: function () {
					var me = this, idx, nextIdx,
						nasPath = fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue();
					
					if (me.sortable) {
						// if (nasPath === '/') {
						// 	return;
						// }
						idx = Ext.Array.indexOf(me.possibleSortStates, me.sortState);
						nextIdx = (idx + 1) % me.possibleSortStates.length;
						me.setSortState(me.possibleSortStates[nextIdx]);
					}
				}
			},{ 
				header: _S('FTP_EXPLORER','SIZE'), 
				dataIndex: 'filesize',
				width: 90,
				renderer: function(value, metaData, record, rowIndex, colIndex, store){
					if(record.data.is_dir == 1){
						return '';
					}else{
						value = record.data.file_size;
						metaData.tdAttr = 'data-qtip="' + AS.ARC.util.convertSizeUnit(value) + '"';
					return AS.ARC.util.convertSizeUnit(value)}
				},
				toggleSortState: function () {
					var me = this, idx, nextIdx,
						nasPath = fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue();
					
					if (me.sortable) {
						// if (nasPath === '/') {
						// 	return;
						// }
						idx = Ext.Array.indexOf(me.possibleSortStates, me.sortState);
						nextIdx = (idx + 1) % me.possibleSortStates.length;
						me.setSortState(me.possibleSortStates[nextIdx]);
					}
				}
			},{ 
				header: _S('FTP_EXPLORER','LAST_MODIFIED'), 
				dataIndex: 'mt',
				width: 150,
				renderer: function(value, metaData, record, rowIndex, colIndex, store){
					
					metaData.tdAttr = 'data-qtip="' + value + '"';
					return value
				},
				toggleSortState: function () {
					var me = this, idx, nextIdx,
						nasPath = fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue();
					
					if (me.sortable) {
						// if (nasPath === '/') {
						// 	return;
						// }
						idx = Ext.Array.indexOf(me.possibleSortStates, me.sortState);
						nextIdx = (idx + 1) % me.possibleSortStates.length;
						me.setSortState(me.possibleSortStates[nextIdx]);
					}
				}
			}],
			width: 437,
			height:412,
			dockedItems:[pagingBar],
			viewConfig: {
				onStoreLoad: Ext.emptyFn,
				focusRow: Ext.emptyFn,
				loadMask: false,
				style: {overflow: 'auto', overflowX: 'hidden'},
				copy: true,
				plugins: {
					ptype: 'gridviewdragdrop',
					ddGroup: 'GridDDGroup',
					dragGroup: 'nasGridDDGroup',
					dropGroup: 'ftpGridDDGroup'
				}
			},
			listeners:{
				columnresize:function( ct, column, width, eOpts ){
					fn.nasGrid.setWidth(fn.nasPanel.width);
				},
				containercontextmenu:function( view, e, eOpts ){
					var sm = fn.nasGrid.getSelectionModel(),
						selections = sm.getSelection();
					
					sm.deselectAll();

					var rightClickMenu = new Ext.menu.Menu({
						itemId: 'nascontainer-menu',
						items: [{
							text: _S('COMMON', 'UPLOAD'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'nascontainer-upload',
							disabled: true,
							handler: function () {
								var type = '[DIR]',
									ftpPath = fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue(),
									nasPath = fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue();
								
								upload({
									src: type + nasPath,
									dst: ftpPath
								});
							},
							scope: this
						},{
							text: _S('COMMON', 'CREATE_FOLDER'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'nascontainer-create-folder',
							disabled: true,
							handler: function () {
								LocalCreateFolder(fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue());
							},
							scope: this
						},{
							text: _S('COMMON', 'DELETE'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'nascontainer-delete',
							disabled: true,
							handler: function () {
								var file = '';
								selections.each(function(record){
									file += (file == '')? '': '/';
									file += record.data.filename;
								});
								LocalRemove(fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue(), file);
							},
							scope: this
						}, {
							text: _S('COMMON', 'RENAME'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'nascontainer-rename',
							disabled: true,
							handler: function () {
								LocalRename(fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue(),record.data.text);
							},
							scope: this
						},{
							text: _S('FTP_EXPLORER', 'OPEN_IN'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'nascontainer-open-in',
							disabled: true,
							menu:{
								items:[{
									text:_S('FTP_EXPLORER', 'FILEEXPLORER'),
									scale: AS.ARC.config.defaultActionButtonSize,
									itemId: 'file-explorer',
									handler: function () {
										AS.ARC.core.openApp('app-fileExplorer',fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue());
									},
									scope: this
								}]
							},
							scope: this
						},{
							text: _S('FTP_EXPLORER', 'SELECT_ALLPAGE_ITEMS'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'nascontainer-select-all-items',
							handler: function () {
								sm.selectAll();
							},
							scope: this
						},{
							text: _S('FTP_EXPLORER', 'BACKTO_HOME_FOLDER'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'nascontainer-back-home-folder',
							handler: function () {
								var nasPagingBar =  fn.nasGrid.dockedItems.items[1];
								fn.nasStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiFileExplorerUrl,{act:'file_list',path:''});
								fn.nasPanel.dockedItems.items[0].items.get('naspath').setValue('/');
								fn.nasStore.load();
								nasPagingBar.store.loadPage(1);
							},
							scope: this
						}], 
						listeners: {
							hide: function (menu) {
								menu.destroy();
							}
						}
					});
					if(fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue() == '/'){
						rightClickMenu.items.get('nascontainer-create-folder').disable();
						//rightClickMenu.items.get('nas-create-shortcut').disable();
						rightClickMenu.items.get('nascontainer-open-in').disable();
						rightClickMenu.items.get('nascontainer-back-home-folder').disable();
					}else{
						rightClickMenu.items.get('nascontainer-create-folder').enable();
						//rightClickMenu.items.get('nas-create-shortcut').enable();
						rightClickMenu.items.get('nascontainer-open-in').enable();
						rightClickMenu.items.get('nascontainer-back-home-folder').enable();
					}
					if(fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue() == '' || fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue() == '/'){
						rightClickMenu.items.get('nascontainer-upload').disable();
					}else{
						rightClickMenu.items.get('nascontainer-upload').enable();
					}
					// e.preventDefault();
					// e.stopEvent();
					rightClickMenu.showAt(e.clientX, e.clientY);
				
				},
				itemdblclick:function(view, record, item, index, e, eOpts){
					if(record.data.is_dir === 1){
						fn.nasPanel.el.mask(_S('COMMON', 'LOADING'));
						fn.nasStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiFileExplorerUrl,{act:'file_list',path:record.data.file_path});
						fn.nasStore.load();
						fn.nasPanel.dockedItems.items[0].items.get('naspath').setValue(record.data.file_path);
					}
				},
				itemcontextmenu:function( view, record, htmlItem, rowIndex, e, eOpts ){
					var sm = fn.nasGrid.getSelectionModel(),
						selections = sm.getSelection();
					
					if (selections.length <= 1 || !sm.isSelected(record)) {
						sm.select(record);
					}
					
					selections = sm.getSelection();
					
					var rightClickMenu = new Ext.menu.Menu({
						itemId: 'nas-menu',
						items: [{
							text: _S('COMMON', 'UPLOAD'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'nas-upload',
							handler: function () {
								var ftpPath = fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue(),
									nasPath = fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue();
								
								var config = {
									src: '',
									dst: ftpPath
								};
								
								for (var i = 0; i<selections.length ; i++) {
									var type = '';
									var path = '';
									if (selections[i].data.is_dir === 1) {
										type ='[DIR]';
										path = selections[i].data.file_path;
									}else{
										type = '[FILE]';
										path = selections[i].data.file_path;
									}
									config.src += config.src == '' ? '' : '|||';
									config.src += type + path ;
								}
								upload(config);
							},
							scope: this
						},{
							text: _S('COMMON', 'CREATE_FOLDER'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'nas-create-folder',
							handler: function () {
								LocalCreateFolder(fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue());
							},
							scope: this
						},{
							text: _S('COMMON', 'DELETE'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'nas-delete',
							handler: function () {
								var file = '';
								selections.each(function(record){
									file += (file == '')? '': '/';
									file += record.data.filename;
								});
                                var totalSelect = selections.length;
								LocalRemove(fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue(), file, totalSelect);
							},
							scope: this
						}, {
							text: _S('COMMON', 'RENAME'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'nas-rename',
							handler: function () {
								LocalRename(fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue(),record.data.filename);
							},
							scope: this
						}, {
							text: _S('FTP_EXPLORER', 'OPEN_IN'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'nas-open-in',
							menu:{
								items:[{
									text:_S('FTP_EXPLORER', 'FILEEXPLORER'),
									scale: AS.ARC.config.defaultActionButtonSize,
									itemId: 'file-explorer',
									handler: function () {
										AS.ARC.core.openApp('app-fileExplorer',record.data.file_path);
									},
									scope: this
								}]
							},
							scope: this
						},{
							text: _S('FTP_EXPLORER', 'SELECT_ALLPAGE_ITEMS'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'nas-select-all-items',
							handler: function () {
								sm.selectAll();
							},
							scope: this
						},{
							text: _S('FTP_EXPLORER', 'BACKTO_HOME_FOLDER'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'nas-back-home-folder',
							handler: function () {
								var nasPagingBar =  fn.nasGrid.dockedItems.items[1];
								fn.nasStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiFileExplorerUrl,{act:'file_list',path:''});
								fn.nasPanel.dockedItems.items[0].items.get('naspath').setValue('/');
								fn.nasStore.load();
								nasPagingBar.store.loadPage(1);
							},
							scope: this
						}],
						listeners: {
							hide: function (menu) {
								menu.destroy();
							}
						}
					});
					if(fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue() == '/'){
						rightClickMenu.items.get('nas-back-home-folder').disable();
						rightClickMenu.items.get('nas-create-folder').disable();
						rightClickMenu.items.get('nas-rename').disable();
						rightClickMenu.items.get('nas-delete').disable();
					}else{
						rightClickMenu.items.get('nas-back-home-folder').enable();
					}
					if(fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue() == ''){
						rightClickMenu.items.get('nas-upload').disable();
					}else{
						rightClickMenu.items.get('nas-upload').enable();
					}
					if (selections.length > 1){
						rightClickMenu.items.get('nas-rename').disable();
						rightClickMenu.items.get('nas-open-in').disable();
					}
					e.preventDefault();
					e.stopEvent();
					rightClickMenu.showAt(e.getXY());
				},
				afterrender: function(grid) { // NAS grid
					var gridView = grid.getView(),
						dropZone = gridView.plugins[0].dropZone,
						dragZone = gridView.plugins[0].dragZone;
					
					/** fix dnd action 'cause apply perfect scrollbar */
					grid.el.dom.addEventListener('contextmenu', function(e) {
						grid.getView().fireEvent('containercontextmenu', grid.getView(), e);
					});
					grid.el.dom.on('mousemove', function(e) {
						if (fn.dragData !== undefined) {
							if (dragZone.dragging !== true)
								dropZone.onContainerOver(dragZone, e, fn.dragData);
							else {
								var dragTextDiv = dropZone.DDMInstance.dragCurrent.ddel;
								dragTextDiv.update(fn.dragText);
								dragTextDiv.dom.offsetParent.removeClassName('x-dd-drop-ok');
							}	
						}
					});
					grid.el.dom.on('mouseup', function(e) {
						if (dropZone.valid && fn.dragData && !fn.isOnNode && !dragZone.dragging) {
							dropZone.handleNodeDrop(fn.dragData);
						}
						fn.dragData = undefined;
					});
					
					// Drag
					dragZone.dragText = _S('FTP_EXPLORER', 'N_RECORD_SELECTED');
					
					dragZone.startDrag = function (x, y) {
						var me = this,
							proxy = me.getProxy(),
							ddStyle = proxy.getEl().dom.style;
						
						fn.dragData = me.dragData;

						proxy.getEl().shadow = false;
						ddStyle.border = '1px solid #AAA';
						ddStyle.background = '#EEE';
						ddStyle.opacity = '0.9';
						
						proxy.reset();
						proxy.update("");
						proxy.show();
						me.onInitDrag(x, y);
						me.dragging = true;
						fn.dragText = me.ddel.dom.innerText;
					};
					dragZone.beforeDragOver = function(target){
						var me = this;
						
						me.proxy.el.setZIndex(target.view.getZIndexParent().el.getZIndex() + 1);
						return true;
					};
					dragZone.getRepairXY = function () {
						return false;
					};
					
					// Drop
					dropZone.onNodeOver = function(node, dragZone, e, data) {
						var me = this,
							overRecord = me.view.getRecord(node),
							nasPath = fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue();
						
						me.overRecord = overRecord;
						fn.record = overRecord;
						
						if (overRecord.data.type === 'dir') {
							data.ddel.update(Ext.String.format(_S('FTP_EXPLORER', 'DL_FOLDER'), overRecord.data.text));
						} else {
							data.ddel.update(_S('FTP_EXPLORER', 'DL_HERE'));
						}
						
						if (nasPath !== '' || (nasPath !== '/' && typeof me.view.getRecord(node) !== 'undefined')) {
							me.valid = true;
							return me.dropAllowed;
						} else {
							me.valid = false;
							return me.dropNotAllowed;
						}
					};
					dropZone.onNodeEnter= function( nodeData, source, e, data ) {
						fn.isOnNode = true;
					}
					dropZone.onNodeOut = function( nodeData, source, e, data ) {
						fn.isOnNode = false;
					};
					dropZone.onContainerOver = function(dd, e, data) {
						var me = this,
							view = me.view,
							count = view.store.getCount(),
							nasPath = fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue(),
							dragTextDiv = data.ddel.dom.offsetParent;

						if (count) {
							if (nasPath === '' || nasPath === '/') {
								data.ddel.update(_S('FTP_EXPLORER', 'UNABLE_DL_ROOT'));
								
								me.valid = false;
								return me.dropNotAllowed;
							}
						} else {
							delete me.overRecord;
							delete me.currentPosition;
						}
						
						data.ddel.update(_S('FTP_EXPLORER', 'DL_HERE'));
						dragTextDiv.addClassName('x-dd-drop-ok');
						me.valid = true;
						return me.dropAllowed;
					};
					dropZone.notifyOut = function (dragZone, e, data) {
						var me = this;
						data.ddel.update(dragZone.getDragText());
						
						me.callParent(arguments);
						delete me.overRecord;
						delete me.currentPosition;
						if (me.indicator) {
							me.indicator.hide();
						}
					};
					dropZone.handleNodeDrop = function (data, record, position) {
						var me = this,
							nasPath = fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue();
						
						var config = {
							src: '',
							dst: ''
						};

						for (var i = 0; i < data.records.length ; i++) {
							var type = '';
							var path = '';
							if (data.records[i].data.type == 'dir') {
								type ='[DIR]';
								path = data.records[i].data.path;
							} else {
								type = '[FILE]';
								path = data.records[i].data.path;
							}
							config.src += config.src == '' ? '' : '|||';
							config.src += type + path;
						}
						
						if (record && record.data.is_dir === 1) {
							config.dst = record.data.file_path;
						} else {
							config.dst = nasPath;
						}
						download(config);
						delete me.overRecord;
					};
				}
			}
		});
		//fix ftp grid paging bar
		var nasButtonSize = Ext.create('Ext.button.Button', {
			text: fn.nasPageSize,
			margin: '0 0 0 0',
			itemId: 'nas-button-size',
			checked: false,
			menu: [{
				text: '10',
				checked: false,
				group: 'nas-pagesize',
				itemId: '10',
				handler: function () {				
					fn.nasPageSize = 10;
					nasPagingBar.store.pageSize = 10;
					nasPagingBar.store.loadPage(1);
				},
				listeners : {
					click: function(button, event) {
						nasButtonSize.setText(fn.nasPageSize);
					}
				}
			},{
				text: '30',
				checked: true,
				group: 'nas-pagesize',
				itemId: '30',
				handler: function () {				
					fn.nasPageSize = 30;
					nasPagingBar.store.pageSize = 30;
					nasPagingBar.store.loadPage(1);
				},
				listeners : {
					click: function(button, event) {
						nasButtonSize.setText(fn.nasPageSize);
					}
				}
			},{
				text: '50',
				checked: false,
				group: 'nas-pagesize',
				itemId: '50',
				handler: function () {				
					fn.nasPageSize = 50;
					nasPagingBar.store.pageSize = 50;
					nasPagingBar.store.loadPage(1);
				},
				listeners : {
					click: function(button, event) {
						nasButtonSize.setText(fn.nasPageSize);
					}
				}
			},{
				text: '100',
				checked: false,
				group: 'nas-pagesize',
				itemId: '100',
				handler: function () {				
					fn.nasPageSize = 100;
					nasPagingBar.store.pageSize = 100;
					nasPagingBar.store.loadPage(1);
				},
				listeners : {
					click: function(button, event) {
						nasButtonSize.setText(fn.nasPageSize);
					}
				}
			},{
				text: '500',
				checked: false,
				group: 'nas-pagesize',
				itemId: '500',
				handler: function () {				
					fn.nasPageSize = 500;
					nasPagingBar.store.pageSize = 500;
					nasPagingBar.store.loadPage(1);
				},
				listeners : {
					click: function(button, event) {
						nasButtonSize.setText(fn.nasPageSize);
					}
				}
			}]
		});
		fn.nasPanel = new Ext.panel.Panel({
			region: 'west',
			cls: 'as-nas-panel',
			split: true,
			width: 510,
			layout:'fit',
			border:true,
			minWidth:345,
			dockedItems: [{
				xtype: 'panel',
                cls: 'naspanel',
				dock: 'top',
				border: false,
				height: 40,
				layout:'hbox',
				items: [{
					xtype: 'container',
					itemId: 'nasfolder',
                    height:40,
                    width: 50,
                    cls: 'folder-img-container',
                    items: {
                        xtype: 'container',
                        cls: 'folder-img'
                    },
					listeners:{
						render:function(img){
							Ext.fly(this.el).on('click', function(e, t) {
								if(fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue() == '/' || fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue() == ''){
								}else{
									fn.nasPanel.el.mask(_S('COMMON', 'LOADING'));
									var upperpath = fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue().split('/'),
										newpath = '';
									if(upperpath.length > 2 && !(upperpath.length === 3 && upperpath[1] === 'home')){
										for(var i = 0; i< upperpath.length-1 ; i++){
											newpath += i == 0 ?'':'/';
											newpath +=  upperpath[i];
										}
										fn.nasStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiFileExplorerUrl,{act:'file_list',path:newpath});
									}else{
										newpath = '/';
										fn.nasStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiFileExplorerUrl,{act:'file_list',path:''});
									}
									// fn.nasGrid.dockedItems.items[1].store.loadPage(1);
									fn.nasStore.load();
									fn.nasPanel.dockedItems.items[0].items.get('naspath').setValue(newpath);
								}
								
							});	
						}
					
					}
				}, {
					xtype: 'textfield',
					cls: 'path',
					height: 39,
					readOnly: true,
					itemId: 'naspath',
					value: '/',
					listeners: {
						afterrender: function(text) {
							text.el.dom.setAttribute('data-qtip', '/');
						},
						change: function(text, newValue) {
							text.el.dom.setAttribute('data-qtip', newValue);
						}
					}
				}]
			}],
			items:[
				fn.nasGrid
			],
			listeners:{
				resize:function( panel, width, height, eOpts ){
					fn.nasGrid.setWidth(width);
					fn.nasGrid.setHeight(height-38);
					panel.dockedItems.items[0].items.get('naspath').setWidth(width-67);
					setTimeout(function() {
						var panelBody = fn.nasGrid.el.dom.querySelector('.x-panel-body');
						Ps.update(panelBody);
					}, 200);
				}
			}
		});
		fn.ftpStore = Ext.create('Ext.data.JsonStore', {
			pageSize:fn.ftpPageSize,
			autoDestroy: true,
			remoteSort: true,
			fields: [
				'path',
				'text',
				'type',
				'filesize',
				'mt'
			],
			sorters: [{property:'text', direction:'ASC'}],
			proxy: {
				type: 'ajax',
				url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act:'ftp_list',ftp_dir:''}),
				timeout: 90 * 1000,
				reader: {
					type: 'json',
					root: 'items',
					totalProperty: 'All'
				},
				actionMethods: {
					create: 'POST', read: 'POST', update: 'POST', destroy: 'POST'
				},
				simpleSortMode: true,
				directionParam: 'dirway',
				sortParam: 'sortway',
				listeners: {
					exception: function (proxy, response, operation, opts) {
						fn.ftpPanel.el.unmask();
						
						if (!isConnected()) { fn.ftpGrid.store.loadData([]); return;}
						
						var errors = {
							5005: _S('FTP_EXPLORER', 'ERROR_5005'),
							5401: _S('FTP_EXPLORER', 'ERROR_5401'),
							5011: _S('FTP_EXPLORER','ERROR_5011'),
							5607: _S('COMMON', 'MSG_CONNECTION_LOST'),
							5618: _S('FTP_EXPLORER','ERROR_5618')
						};
						
						if (5011 === Ext.JSON.decode(response.responseText).error_code) {
							fn.ftpPanel.prevPath();
						} else {
							fn.ftpGrid.store.loadData([]);
							fn.ftpPanel.dockedItems.items[0].items.get('ftppath').setValue('');
						}
						
						AS.ARC.util.showMsgWindow(errors, Ext.JSON.decode(response.responseText), fn.win);
					}
				}
			},
			listeners:{
				beforeload:function(store, operation){
					operation.sorters[0].direction = operation.sorters[0].direction.toLowerCase();
					if(typeof (fn.ftpPanel !== 'undefined')){
						fn.ftpPanel.el.mask(_S('COMMON', 'LOADING'));
					}
				},
				load:function(store, records, successful, operation, eOpts) {
					if(successful){
						if(fn.ftpStore.proxy.url.split('act=ftp_list&ftp_dir=')[1] == ''){
							fn.ftpPanel.dockedItems.items[0].items.get('ftppath').setValue('/');
						}
					}
					fn.ftpPanel.el.unmask();
				}
			}
		});
		fn.ftpGrid = new Ext.create('Ext.grid.Panel', {
			store: fn.ftpStore,
			multiSelect: true,
            autoScroll: true,
			margin:'0 1 0 0',
			columns: [{
				header: _S('FTP_EXPLORER','NAME'),  
				dataIndex: 'text',
				flex: 2,
				renderer: function(value, metaData, record, rowIndex, colIndex, store){
					var icon  = '';
					if (record.data.type.toLowerCase() == 'dir') {
						icon = '<img src="'+ fn.imageUrl + 'fileicon/folder_close.png" class="grid-folder-img">&nbsp;<span style="margin-top: -4px;">&nbsp; '+ value +'</span>';
					}else{
						for(var i=0; i < fn.typearray.length; i++){
							if(record.data.type.toLowerCase() == fn.typearray[i]){
								icon = '<img src="'+ fn.imageUrl + 'fileicon/'+ fn.typeUrl[i]+'" class="grid-folder-img" >&nbsp;<span style="margin-top: -4px;">&nbsp; '+ value +'</span>';
								break;
							}else{
								icon = '<img src="'+ fn.imageUrl + 'fileicon/unknow.png" class="grid-folder-img">&nbsp;<span style="margin-top: -4px;">&nbsp; '+ value +'</span>';
							}
						}
					}
					metaData.tdAttr = 'data-qtip="' + value + '"';
					return icon;
				},
				toggleSortState: function () {
					var me = this, idx, nextIdx,
						ftpPath = fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue();
					
					if (me.sortable) {
						if (ftpPath === '') {
							return;
						}
						idx = Ext.Array.indexOf(me.possibleSortStates, me.sortState);
						nextIdx = (idx + 1) % me.possibleSortStates.length;
						me.setSortState(me.possibleSortStates[nextIdx]);
					}
				}
			},{ 	
				header: _S('FTP_EXPLORER','TYPE'), 
				dataIndex: 'type',
				flex: 1,
				renderer: function(value, metaData, record, rowIndex, colIndex, store){
					metaData.tdAttr = 'data-qtip="' + value + '"';
					return value
				},
				toggleSortState: function () {
					var me = this, idx, nextIdx,
						ftpPath = fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue();
					
					if (me.sortable) {
						if (ftpPath === '') {
							return;
						}
						idx = Ext.Array.indexOf(me.possibleSortStates, me.sortState);
						nextIdx = (idx + 1) % me.possibleSortStates.length;
						me.setSortState(me.possibleSortStates[nextIdx]);
					}
				} 
			},{
				header: _S('FTP_EXPLORER','SIZE'), 
				dataIndex: 'filesize',
				flex: 1,
				renderer: function(value, metaData, record, rowIndex, colIndex, store){
					if(record.data.type.toLowerCase() == 'dir'){
						return ''
					}else{
						metaData.tdAttr = 'data-qtip="' + AS.ARC.util.convertSizeUnit(value) + '"';
						return AS.ARC.util.convertSizeUnit(value)
					}
				},
				toggleSortState: function () {
					var me = this, idx, nextIdx,
						ftpPath = fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue();
					
					if (me.sortable) {
						if (ftpPath === '') {
							return;
						}
						idx = Ext.Array.indexOf(me.possibleSortStates, me.sortState);
						nextIdx = (idx + 1) % me.possibleSortStates.length;
						me.setSortState(me.possibleSortStates[nextIdx]);
					}
				}
			},{
				header: _S('FTP_EXPLORER','LAST_MODIFIED'), 
				dataIndex: 'mt',
				flex: 3,
				renderer: function(value, metaData, record, rowIndex, colIndex, store){
					metaData.tdAttr = 'data-qtip="' + value + '"';
					return value
				},
				toggleSortState: function () {
					var me = this, idx, nextIdx,
						ftpPath = fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue();
					
					if (me.sortable) {
						if (ftpPath === '') {
							return;
						}
						idx = Ext.Array.indexOf(me.possibleSortStates, me.sortState);
						nextIdx = (idx + 1) % me.possibleSortStates.length;
						me.setSortState(me.possibleSortStates[nextIdx]);
					}
				}
			}],
			width: 400,
			bbar: Ext.create('AS.ARC.pagingToolbar', {
				store: fn.ftpStore,
				pageSize:fn.ftpPageSize
			}),
			viewConfig: {
				onStoreLoad: Ext.emptyFn,
				focusRow: Ext.emptyFn,
				loadMask: false,
				style: {overflow: 'auto', overflowX: 'hidden'},
				copy: true,
				plugins: {
					ptype: 'gridviewdragdrop',
					ddGroup: 'GridDDGroup',
					dragGroup: 'ftpGridDDGroup',
					dropGroup: 'nasGridDDGroup'
				}
			},
			listeners:{
				afterrender: function(grid) { // FTP grid
					var dragZone = grid.getView().plugins[0].dragZone,
						dropZone = grid.getView().plugins[0].dropZone;

					/** fix dnd action 'cause apply perfect scrollbar */
					grid.el.dom.addEventListener('contextmenu', function(e) {
						grid.getView().fireEvent('containercontextmenu', grid.getView(), e);
					});
					grid.el.dom.on('mousemove', function(e) {
						if (fn.dragData !== undefined) {
							if (dragZone.dragging !== true)
								dropZone.onContainerOver(dragZone, e, fn.dragData);
							else {
								var dragTextDiv = dropZone.DDMInstance.dragCurrent.ddel;
								dragTextDiv.update(fn.dragText);
								dragTextDiv.dom.offsetParent.removeClassName('x-dd-drop-ok');
							}	
						}
					});
					grid.el.dom.on('mouseup', function(e) {
						if (dropZone.valid && fn.dragData && !fn.isOnNode && !dragZone.dragging) {
							dropZone.handleNodeDrop(fn.dragData);
						}
						fn.dragData = undefined;
					});

					// Drag
					dragZone.dragText = _S('FTP_EXPLORER', 'N_RECORD_SELECTED');
					
					dragZone.startDrag = function (x, y) {
						var me = this,
							proxy = me.getProxy(),
							ddStyle = proxy.getEl().dom.style;
						
						fn.dragData = me.dragData;

						proxy.getEl().shadow = false;
						ddStyle.border = '1px solid #AAA';
						ddStyle.background = '#EEE';
						ddStyle.opacity = '0.9';
						
						proxy.reset();
						proxy.update("");
						proxy.show();
						me.onInitDrag(x, y);
						me.dragging = true;
						fn.dragText = me.ddel.dom.innerText;
					};
					dragZone.beforeDragOver = function(target){
						var me = this;
						
						me.proxy.el.setZIndex(target.view.getZIndexParent().el.getZIndex() + 1);
						fn.isDragOver = true;
						return true;
					};
					dragZone.getRepairXY = function () {
						return false;
					};
					
					// Drop
					dropZone.onNodeOver = function(node, dragZone, e, data) {
						var me = this,
							overRecord = me.view.getRecord(node),
							ftpPath = fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue();
						
						me.overRecord = overRecord;
						fn.record = overRecord;
						
						if (overRecord.data.type === 'dir') {
							data.ddel.update(Ext.String.format(_S('FTP_EXPLORER', 'UL_FOLDER'), overRecord.data.text));
						} else {
							data.ddel.update(_S('FTP_EXPLORER', 'UL_HERE'));
						}
						
						if (ftpPath !== '') {
							me.valid = true;
							return me.dropAllowed;
						} else {
							me.valid = false;
							return me.dropNotAllowed;
						}
					};
					dropZone.onNodeEnter= function( nodeData, source, e, data ) {
						fn.isOnNode = true;
					}
					dropZone.onNodeOut = function( nodeData, source, e, data ) {
						fn.isOnNode = false;
					};
					dropZone.onContainerOver = function(dd, e, data) {
						var me = this,
							view = me.view,
							count = view.store.getCount(),
							ftpPath = fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue(),
							dragTextDiv = data.ddel.dom.offsetParent;
						
						if (ftpPath === '' || ftpPath === '/') {
							data.ddel.update(_S('FTP_EXPLORER', 'DESTINATION_INCORRECT'));
							
							me.valid = false;
							return me.dropNotAllowed;
						} else {
							delete me.overRecord;
							delete me.currentPosition;
							
							data.ddel.update(_S('FTP_EXPLORER', 'UL_HERE'));
							dragTextDiv.addClassName('x-dd-drop-ok');
							
							me.valid = true;
							return me.dropAllowed;
						}
					};
					dropZone.notifyOut = function (dragZone, e, data) {
						var me = this;
						data.ddel.update(dragZone.getDragText());
						
						me.callParent(arguments);
						delete me.overRecord;
						delete me.currentPosition;
						if (me.indicator) {
							me.indicator.hide();
						}
					};
					dropZone.handleNodeDrop = function (data, record, position) {
						var me = this,
							ftpPath = fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue();
						
						var config = {
							src: '',
							dst: ''
						};
						
						for (var i = 0; i < data.records.length ; i++) {
							var type = '';
							var path = '';
							if (data.records[i].data.is_dir === 1) {
								type ='[DIR]';
								path = data.records[i].data.file_path;
							}else{
								type = '[FILE]';
								path = data.records[i].data.file_path;
							}
							config.src += config.src == '' ? '' : '|||';
							config.src += type + path ;
						}
						
						if (record && record.data.type === 'dir') {
							config.dst = record.data.path;
						} else {
							config.dst = ftpPath;
						}
						upload(config);
						delete me.overRecord;
					};
				},
				itemdblclick:function( view, record, item, index, e, eOpts ){
					if(record.data.type.toLowerCase() == 'dir'){
						fn.ftpPanel.el.mask(_S('COMMON', 'LOADING'));
						fn.ftpStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act:'ftp_list',ftp_dir:record.data.path});
						fn.ftpStore.load();
						fn.ftpPanel.dockedItems.items[0].items.get('ftppath').setValue(record.data.path);
					}
				},
				itemcontextmenu:function( view, record, htmlItem, rowIndex, e, eOpts ){
					var sm = fn.ftpGrid.getSelectionModel(),
						selections = sm.getSelection();
					
					if (selections.length <= 1 || !sm.isSelected(record)) {
						sm.select(record);
					}
					
					selections = sm.getSelection();
					
					var rightClickMenu = new Ext.menu.Menu({
						itemId: 'ftp-menu',
						items: [{
							text: _S('COMMON', 'DOWNLOAD'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'ftp-download',
							handler: function () {
								var ftpPath = fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue(),
									nasPath = fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue();
								
								var config = {
									src: '',
									dst: nasPath
								};
								
								for (var i = 0; i<selections.length ; i++) {
									var type = '';
									var path = '';
									if (selections[i].data.type == 'dir') {
										type ='[DIR]';
										path = selections[i].data.path;
									}else{
										type = '[FILE]';
										path = selections[i].data.path;
									}
									config.src += config.src == '' ? '' : '|||';
									config.src += type + path ;
								}
								download(config);
							},
							scope: this
						},{
							text: _S('COMMON', 'CREATE_FOLDER'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'ftp-create-folder',
							handler: function () {
								FTPCreateFolder(fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue());
							},
							scope: this
						},{
							text: _S('COMMON', 'DELETE'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'ftp-delete',
							handler: function () {
								var path = '';
								selections.each(function(record){
									path += (path == '')? '': '|||';
									path += record.data.path;
								});
								FTPRemove(path);
							},
							scope: this
						},{
							text: _S('COMMON', 'RENAME'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'ftp-rename',
							handler: function () {
								FTPRename(record.data.text);
							},
							scope: this
						// },{
						// 	text: _S('FTP_EXPLORER', 'COPY_TO_CLIPBOARD'),
						// 	scale: AS.ARC.config.defaultActionButtonSize,
						// 	itemId: 'ftp-copytoclipboard',
						// 	handler: function (btn) {
						// 		if(rightClickMenu && !btn.isDisabled())
						// 			rightClickMenu.close();
						// 	},
						// 	listeners:{
						// 		afterrender:function(Btn){
						// 			if (selections.length === 1) {
						// 				getClipboard(Btn.el.id,Btn.el.dom.down().id,'ftp://' + fn.ftpHost + ':' + fn.ftpPort + record.data.path, Btn);
						// 			}
						// 		}
						// 	},
						// 	scope: this
						},{
							text: _S('FTP_EXPLORER', 'SELECT_ALLPAGE_ITEMS'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'ftp-select-all-items',
							handler: function () {
								sm.selectAll();
							},
							scope: this
						},{
							text: _S('FTP_EXPLORER', 'BACKTO_HOME_FOLDER'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'ftp-back-home-folder',
							handler: function () {
								var ftpPagingBar =  fn.ftpGrid.dockedItems.items[1];
								fn.ftpStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act:'ftp_list',ftp_dir:''});
								//fn.ftpPanel.dockedItems.items[0].items.get('ftppath').setValue('/');
								fn.ftpStore.load();
								ftpPagingBar.store.loadPage(1);
							},
							scope: this
						}], 
						listeners: {
							hide: function (menu) {
								menu.destroy();
							}
						}
					});
					if(fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue() == '/'){
						//rightClickMenu.items.get('ftp-create-folder').disable();
						//rightClickMenu.items.get('ftp-delete').disable();
						//rightClickMenu.items.get('ftp-rename').disable();
					}else{
						rightClickMenu.items.get('ftp-create-folder').enable();
						rightClickMenu.items.get('ftp-delete').enable();
						rightClickMenu.items.get('ftp-rename').enable();
					}
					if(fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue() == '/'){
						rightClickMenu.items.get('ftp-download').disable();
					}
					
					if (selections.length > 1) {
						// rightClickMenu.items.get('ftp-copytoclipboard').disable();
						rightClickMenu.items.get('ftp-rename').disable();
					} else {
						// rightClickMenu.items.get('ftp-copytoclipboard').enable();
						rightClickMenu.items.get('ftp-rename').enable();
					}
					
					e.preventDefault();
					e.stopEvent();
					rightClickMenu.showAt(e.getXY());
				},
				containercontextmenu:function( view, e, eOpts ){
					var sm = fn.ftpGrid.getSelectionModel(),
						selections = sm.getSelection();
					
					sm.deselectAll();
					
					var rightClickMenu = new Ext.menu.Menu({
						itemId: 'ftpcontainer-menu',
						items: [{
							text: _S('COMMON', 'DOWNLOAD'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'ftpcontainer-download',
							disabled:true,
							handler: function () {
								var type = '[DIR]',
									ftpPath = fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue(),
									nasPath = fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue();
								
								download({
									src: type + ftpPath,
									dst: nasPath
								});
							},
							scope: this
						},{
							text: _S('COMMON', 'CREATE_FOLDER'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'ftpcontainer-create-folder',
							disabled:true,
							handler: function () {
								FTPCreateFolder(fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue());
							},
							scope: this
						},{
							text: _S('COMMON', 'DELETE'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'ftpcontainer-delete',
							disabled:true,
							handler: function () {
								
							},
							scope: this
						},{
							text: _S('COMMON', 'RENAME'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'ftpcontainer-rename',
							disabled:true,
							handler: function () {
					
							},
							scope: this
						// },{
						// 	text: _S('FTP_EXPLORER', 'COPY_TO_CLIPBOARD'),
						// 	scale: AS.ARC.config.defaultActionButtonSize,
						// 	itemId: 'ftpcontainer-copytoclipboard',
						// 	disabled:true,
						// 	handler: function () {
								
						// 	},
						// 	scope: this
						},{
							text: _S('FTP_EXPLORER', 'SELECT_ALLPAGE_ITEMS'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'ftpcontainer-select-all-items',
							handler: function () {
								sm.selectAll();
							},
							scope: this
						},{
							text: _S('FTP_EXPLORER', 'BACKTO_HOME_FOLDER'),
							scale: AS.ARC.config.defaultActionButtonSize,
							itemId: 'ftpcontainer-back-home-folder',
							handler: function () {
								var ftpPagingBar =  fn.ftpGrid.dockedItems.items[1];
								fn.ftpStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act:'ftp_list',ftp_dir:''});
								//fn.ftpPanel.dockedItems.items[0].items.get('ftppath').setValue('/');
								fn.ftpStore.load();
								ftpPagingBar.store.loadPage(1);
							},
							scope: this
						}], 
						listeners: {
							hide: function (menu) {
								menu.destroy();
							}
						}
					});
					if(fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue() == ''){
						rightClickMenu.items.get('ftpcontainer-select-all-items').disable();
						rightClickMenu.items.get('ftpcontainer-back-home-folder').disable();
					}else if(fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue() == '/'){
						rightClickMenu.items.get('ftpcontainer-select-all-items').enable();
						rightClickMenu.items.get('ftpcontainer-back-home-folder').enable();
					}else{
						rightClickMenu.items.get('ftpcontainer-select-all-items').enable();
						rightClickMenu.items.get('ftpcontainer-back-home-folder').enable();
						rightClickMenu.items.get('ftpcontainer-download').enable();
						rightClickMenu.items.get('ftpcontainer-create-folder').enable();
					}
					if(fn.nasPanel.dockedItems.items[0].items.get('naspath').getValue() == '/'){
						rightClickMenu.items.get('ftpcontainer-download').disable();
					}
					// e.preventDefault();
					// e.stopEvent();
					rightClickMenu.showAt(e.clientX, e.clientY);
				}
			}
		});
		//fix ftp grid paging bar
		var ftpButtonSize = Ext.create('Ext.button.Button', {
			text: fn.ftpPageSize,
			margin: '0 0 0 0',
			itemId: 'ftp-button-size',
			checked: false,
			menu: [{
				text: '10',
				checked: false,
				group: 'ftp-pagesize',
				itemId: '10',
				handler: function () {				
					fn.ftpPageSize = 10;
					ftpPagingBar.store.pageSize = 10;
					ftpPagingBar.store.loadPage(1);
				},
				listeners : {
					click: function(button, event) {
						ftpButtonSize.setText(fn.ftpPageSize);
					}
				}
			},{
				text: '30',
				checked: true,
				group: 'ftp-pagesize',
				itemId: '30',
				handler: function () {				
					fn.ftpPageSize = 30;
					ftpPagingBar.store.pageSize = 30;
					ftpPagingBar.store.loadPage(1);
				},
				listeners : {
					click: function(button, event) {
						ftpButtonSize.setText(fn.ftpPageSize);
					}
				}
			},{
				text: '50',
				checked: false,
				group: 'ftp-pagesize',
				itemId: '50',
				handler: function () {				
					fn.ftpPageSize = 50;
					ftpPagingBar.store.pageSize = 50;
					ftpPagingBar.store.loadPage(1);
				},
				listeners : {
					click: function(button, event) {
						ftpButtonSize.setText(fn.ftpPageSize);
					}
				}
			},{
				text: '100',
				checked: false,
				group: 'ftp-pagesize',
				itemId: '100',
				handler: function () {				
					fn.ftpPageSize = 100;
					ftpPagingBar.store.pageSize = 100;
					ftpPagingBar.store.loadPage(1);
				},
				listeners : {
					click: function(button, event) {
						ftpButtonSize.setText(fn.ftpPageSize);
					}
				}
			},{
				text: '500',
				checked: false,
				group: 'ftp-pagesize',
				itemId: '500',
				handler: function () {				
					fn.ftpPageSize = 500;
					ftpPagingBar.store.pageSize = 500;
					ftpPagingBar.store.loadPage(1);
				},
				listeners : {
					click: function(button, event) {
						ftpButtonSize.setText(fn.ftpPageSize);
					}
				}
			}]
		});
		fn.ftpPanel = new Ext.panel.Panel({
			region: 'center',
			cls: 'as-ftp-panel',
			width:440,
			layout:'fit',
			border:false,
            minWidth:345,
			prevPath: function () {
				if(fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue() == '/' || fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue() == ''){
				}else{
					fn.ftpPanel.el.mask(_S('COMMON', 'LOADING'));
					var upperpath = fn.ftpPanel.dockedItems.items[0].items.get('ftppath').getValue().split('/'),
						newpath = '';
					if(upperpath.length > 2){
						for(var i = 0; i< upperpath.length-1 ; i++){
							newpath += i == 0 ?'':'/';
							newpath +=  upperpath[i];
						}
						fn.ftpStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act:'ftp_list',ftp_dir:newpath});
					}else{
						newpath = '/';
						fn.ftpStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act:'ftp_list',ftp_dir:''});
					}
					// fn.ftpGrid.dockedItems.items[1].store.loadPage(1);
					fn.ftpStore.load();
					fn.ftpPanel.dockedItems.items[0].items.get('ftppath').setValue(newpath);
				}
			},
			dockedItems: [{
				xtype: 'panel',
                cls: 'naspanel',
				dock: 'top',
				border: false,
				height: 40,
				layout:'hbox',
				items: [{
					xtype: 'container',
					itemId: 'ftpfolder',
                    height:40,
                    width: 50,
                    cls: 'folder-img-container',
                    items: {
                        xtype: 'container',
                        cls: 'folder-img'
                    },
					listeners:{
						render:function(img){
							Ext.fly(this.el).on('click', function(e, t) {
								fn.ftpPanel.prevPath();
							});
						}
					
					}
				},{
					xtype: 'textfield',
                    cls: 'path',
					height:39,
					readOnly:true,
					itemId: 'ftppath',
					listeners:{
						afterrender: function(text) {
							text.el.dom.setAttribute('data-qtip', '');
						},
						change: function(text, newValue) {
							text.el.dom.setAttribute('data-qtip', newValue);
						}
					}
				}]
			}],
			items:[
				fn.ftpGrid
			],
			listeners:{
				resize:function( panel, width, height, eOpts ){
					fn.ftpGrid.setWidth(width-3);
					fn.ftpGrid.setHeight(height-38);
					panel.dockedItems.items[0].items.get('ftppath').setWidth(width-67);
					setTimeout(function() {
						var panelBody = fn.ftpGrid.el.dom.querySelector('.x-panel-body');
						Ps.update(panelBody);
					}, 200);
				}
			}
		});
		// Window of ftpexplorer Server 
		fn.win = fn.desktop.createWindow({
			app: fn.app,
			id: fn.id,
			itemId: fn.id,
			resizable: true,
			maximizable: true,
			border: false,
			layout : 'border',
			items: [
				fn.connectpanel,
				fn.nasPanel,
				fn.ftpPanel,
				fn.infomationpanel
			],
			listeners: {
				afterrender: function (win) {
					if(fn.connectpanel.items.get('hostIP').getValue() === '') 
						disconnect();
					win.header.items.items[1].hide();
					AS.ARC.ajax({
						url: AS.ARC.util.getApiUrlWithSid(fn.apiUrl, {act:'get_active_host'}), // TODO
						method: 'post',
						success: function (json, opts) {
							if(typeof json !== 'undefined'){
								if(json.Host) {
									
									fn.connectpanel.items.get('disconnect').enable();
								
									fn.connectpanel.items.get('hostIP').setValue(json.Host);
									fn.connectpanel.items.get('port').setValue(json.Port);
									fn.connectpanel.items.get('username').setValue(json.Username);
									fn.connectpanel.items.get('password').setValue(json.Password);
									fn.ftpHost = json.Host;
									fn.ftpPort = json.Port;
									fn.ftpStore.proxy.url = AS.ARC.util.getApiUrlWithSid(fn.apiUrl,{act:'ftp_list',ftp_dir:''});
									fn.ftpStore.load();
									fn.ftpPanel.dockedItems.items[0].items.get('ftppath').setValue('/');
								} else {
									fn.connectpanel.items.get('disconnect').disable();
								}
							}
						},
						failure: function (json, opts) {
							fn.connectpanel.items.get('disconnect').disable();
						}
					});
				},
				maximize: function(win, eOpts) {
					win.resizer.disable();
				},
				restore: function(win, eOpts) {
					win.resizer.enable();
				},
				beforeclose: function () {
					if(typeof fn.activityID !== 'undefined'){
						clearTimeout(fn.activityID);
					}
					
					disconnect(true);
				},
				resize: function (panel, width, height, eOpts) {
					var nw = width;
					
					if (fn.ftpPanel.getWidth() >= width) {
						nw = Math.floor(width / 2);
						fn.ftpPanel.setWidth(nw);
					} else if (fn.nasPanel.getWidth() >= width) {
						nw = Math.floor(width / 2);
						fn.nasPanel.setWidth(nw);
					}
					
					fn.connectpanel.doComponentLayout();
					fn.nasPanel.doComponentLayout();
					fn.ftpPanel.doComponentLayout();
					fn.infomationpanel.doComponentLayout();
				},
				show: function () {
					fn.infomationpanel.doComponentLayout();
				}
			}
		});
	}
});

/**
 * @class AS.ARC.apps.ftpexplorer.main
 * @extends AS.ARC._appBase
 * <p>Main app</p>
 */
Ext.define('AS.ARC.apps.ftpexplorer.main', {
	extend: 'AS.ARC._appBase',

	appTag: 'ftpexplorer',
	title: _S('FTP_EXPLORER', 'FTP_EXPLORER'),
	appMaxNum: 1,
	appOpenNum: 0,
	appIsReady: true,
	appWins: [],
	
	createWindow: function () {
		var desktop = this.core.getDesktop(),
			app = this;
		
		if ((this.appOpenNum === this.appMaxNum) || !this.appIsReady) {
			this.appWins[0].show();
			return;
		}
		
		// Set appIsReady to false
		this.appIsReady = false;

		var newFtpexplorer = new AS.ARC.apps.ftpexplorer.core({
			app: this,
			desktop: desktop,
			id: this.id + '-' + Ext.id()
		});
		
		newFtpexplorer.win.on('render', function () {
			app.appOpenNum++;
			app.appIsReady = true;
		});		
	
		newFtpexplorer.win.on('beforeclose', function () {
			app.appOpenNum--;
			app.appIsReady = true;
			app.appWins.pop();
		});		
		newFtpexplorer.win.show();
		
		// Get all wins for handling
		this.appWins.push(newFtpexplorer.win);
	}
});